//+------------------------------------------------------------------+
//|                                                       IncGUI.mqh |
//|                                                          Integer |
//|                          https://login.mql5.com/ru/users/Integer |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "https://login.mql5.com/ru/users/Integer"

/*
      :
   
   1.  CGraphicObjectShell.
   2.   CGraphicObjectShell   "g".
   3.  CWorkPiece.
   4.   CWorkPiece   "w".
   5.  CColorSchemes.
   6.   CColorSchemes   "ClrScheme".
   7.   .  
      7.1.  CInputBox ( ).
*/

//+------------------------------------------------------------------+
//|                                                                  |
//|          CGraphicObjectShell                                |
//|                                                                  |
//+------------------------------------------------------------------+

/*!
	\brief     ,   .
	
	\details       ,     
	             .      .
	         
	                 "Create",   
	             : , , . 
	         
	                "Set".     
	             : 1)  , 2)    
	         ( ), 3)    (, ).
	         
	          1         . 
	                    
	          Create...()    Attach().  2   
	               "" ,  3 -  
	            .
	         
   \remark	       "g".
*/
class CGraphicObjectShell{
   protected:
      string m_name;
      long m_id;
   public:
   
      /*
      
           :
      
         1.  .
         2. .
         
         3.     .
         4.    .
         
         5.     .
         6.     .
         
         7.        .
         8.        .
         
         9.  .
      */
      
      //+------------------------------------------------------------------+
      //|                                                          |
      //+------------------------------------------------------------------+
   
		/*!	
			  .
		 	\param		string aName -    ,
		 	\param		long aChartID=0 -       .
		*/
      void Attach(string aName,long aChartID=0){
         m_name=aName;
         m_id=aChartID;
      }
      
		/*!	
			    .
         \return     .
		*/		
      string Name(){return(m_name);}   
      
		/*!	
			     .
         \return     .
		*/      
      long ChartID(){return(m_id);}
      
      //+------------------------------------------------------------------+
      //|                                                          |
      //+------------------------------------------------------------------+      
		
		/*!	
			  " " OBJ_VLINE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateVLine           (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_VLINE,             aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_HLINE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/        
      void CreateHLine           (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_HLINE,             aSubWindow,0,0);Attach(aName,aChartID);}

		/*!	
			  " " OBJ_TREND.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/       
      void CreateTrend           (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_TREND,             aSubWindow,0,0);Attach(aName,aChartID);}

		/*!	
			  "   " OBJ_TRENDBYANGLE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/           
      void CreateTrendByAngle    (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_TRENDBYANGLE,      aSubWindow,0,0);Attach(aName,aChartID);}

		/*!	
			  " " OBJ_CHANNEL.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/        
      void CreateChannel         (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_CHANNEL,           aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "  " OBJ_STDDEVCHANNEL.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/        
      void CreateStdDevChannel   (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_STDDEVCHANNEL,     aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "  " OBJ_REGRESSION.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/        
      void CreateRegresion       (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_REGRESSION,        aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_PITCHFORK.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreatePitchFork       (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_PITCHFORK,         aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_GANNLINE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateGannLine        (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_GANNLINE,          aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_GANNFAN.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateGannFan         (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_GANNFAN,           aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_GANNGRID.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateGannGrid        (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_GANNGRID,          aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_FIBO.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateFibo            (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_FIBO,              aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "  " OBJ_FIBOTIMES.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateFiboTimes       (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_FIBOTIMES,         aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_FIBOFAN.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateFiboFan         (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_FIBOFAN,           aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_FIBOARC.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateFiboArc         (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_FIBOARC,           aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_FIBOCHANNEL.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateFiboChannel     (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_FIBOCHANNEL,       aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_EXPANSION.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateExpansion       (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_EXPANSION,         aSubWindow,0,0);Attach(aName,aChartID);}	
		
		/*!	
			  "5-  " OBJ_ELLIOTWAVE5.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateElliotWave5     (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ELLIOTWAVE5,       aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "3-  " OBJ_ELLIOTWAVE3.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateElliotWave3     (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ELLIOTWAVE3,       aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_RECTANGLE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateRectangle       (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_RECTANGLE,         aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_TRIANGLE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateTriangle        (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_TRIANGLE,          aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_ELLIPSE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateEllipse         (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ELLIPSE,           aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_CYCLES.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateCycles          (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_CYCLES,            aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" (  ) OBJ_ARROW_THUMB_UP.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateThumbUp         (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_THUMB_UP,    aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" (  ) OBJ_ARROW_THUMB_DOWN.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateTumbDn          (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_THUMB_DOWN,  aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_ARROW_UP.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowUp         (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_UP,          aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_ARROW_DOWN.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowDn         (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_DOWN,        aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_ARROW_STOP.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowStop       (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_STOP,        aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" () OBJ_ARROW_CHECK.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowCheck      (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_CHECK,       aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "  " OBJ_ARROW_LEFT_PRICE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowLeftPrice  (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_LEFT_PRICE,  aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "  " OBJ_ARROW_RIGHT_PRICE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowRightPrice (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_RIGHT_PRICE, aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "Buy" OBJ_ARROW_BUY.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowBuy        (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_BUY,         aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "Sell" OBJ_ARROW_SEL.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowSell       (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW_SELL,        aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_ARROW.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrow           (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROW,             aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_TEXT.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateText            (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_TEXT,              aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_LABEL.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateLabel           (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_LABEL,             aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_BUTTON.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateButton          (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_BUTTON,            aSubWindow,0,0);Attach(aName,aChartID);}	      
		
		/*!	
			  "" OBJ_CHART.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateChart           (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_CHART,             aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_BITMAP.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateBitmap          (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_BITMAP,            aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_BITMAP_LABEL.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreatePitmapLabel     (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_BITMAP_LABEL,      aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_EDIT.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateEdit            (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_EDIT,              aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "  " OBJ_ARROWED_LINE.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateArrowedLine     (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_ARROWED_LINE,      aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  "" OBJ_EVENT.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateEvent           (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_EVENT,             aSubWindow,0,0);Attach(aName,aChartID);}
		
		/*!	
			  " " OBJ_RECTANGLE_LABEL.
		 	\param		string aName -    ,
		 	\param		int aSubWindow=0 -      ,
		 	\param		long aChartID=0 -       .			
		*/  
      void CreateRectangleLabel  (string aName,int aSubWindow=0,long aChartID=0){ObjectCreate(aChartID,aName,OBJ_RECTANGLE_LABEL,   aSubWindow,0,0);Attach(aName,aChartID);}

      //+------------------------------------------------------------------+
      //|                         |
      //+------------------------------------------------------------------+         

		/*!	
			 OBJPROP_COLOR.
		 	\return    ( color).		
		*/  
      color                   Color       ()             {return( (color)                    ObjectGetInteger(m_id,m_name,OBJPROP_COLOR));}

		/*!	
			 OBJPROP_STYLE.
		 	\return    ( ENUM_LINE_STYLE).		
		*/        
      ENUM_LINE_STYLE         Style       ()             {return( (ENUM_LINE_STYLE)          ObjectGetInteger(m_id,m_name,OBJPROP_STYLE));}

		/*!	
			 OBJPROP_WIDTH.
		 	\return    ( int).		
		*/         
      int                     Width       ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_WIDTH));} 

		/*!	
			     OBJPROP_BACK.
		 	\return   bool. True -   , false -  .		
		*/        
      bool                    Back        ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_BACK));} 	

		/*!	
			   OBJPROP_FILL ( OBJ_RECTANGLE, OBJ_TRIANGLE, OBJ_ELLIPSE, OBJ_CHANNEL, OBJ_STDDEVCHANNEL, OBJ_REGRESSION)
		 	\return   bool. True - , false - .	
		*/       
      bool                    Fill        ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_FILL));} 		

		/*!	
			  OBJPROP_SELECTED.
		 	\return   bool. True - , false -  .	
		*/       
      bool                    Selected    ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_SELECTED));} 		

		/*!	
			     " " OBJPROP_SELECTED.
		 	\return   bool. True -  , false - .	
		*/  
      bool                    ReadOnly    ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_READONLY));} 		

		/*!	
			  OBJPROP_TYPE.
		 	\return   ENUM_OBJECT.	
		*/       
      ENUM_OBJECT             Type        ()             {return( (ENUM_OBJECT)              ObjectGetInteger(m_id,m_name,OBJPROP_TYPE));}

		/*!	
			      OBJPROP_TIME.
         \param   int aIndex -    ( ).
		 	\return    ( datetime).		
		*/       
      datetime                Time        (int aIndex)   {return( (datetime)                 ObjectGetInteger(m_id,m_name,OBJPROP_TIME,aIndex));}	

		/*!	
			   OBJPROP_SELECTABLE.
		 	\return   bool. True -  , false - .	
		*/         
      bool                    Selectable  ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_SELECTABLE));} 		

		/*!	
			   OBJPROP_CREATETIME.
		 	\return    ( datetime).		
		*/       
      datetime                CreateTime  ()             {return( (datetime)                 ObjectGetInteger(m_id,m_name,OBJPROP_CREATETIME));}	

		/*!	
			  OBJPROP_LEVELS).
		 	\return   ( int).		
		*/    
      int                     Levels      ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_LEVELS));}	

		/*!	
			  OBJPROP_LEVELCOLOR.
         \param   int aIndex -   ( ).
		 	\return    ( color).		
		*/  
      color                   LevelColor  (int aIndex)   {return( (color)                    ObjectGetInteger(m_id,m_name,OBJPROP_LEVELCOLOR,aIndex));}		

		/*!	
			  OBJPROP_LEVELSTYLE.
         \param   int aIndex -   ( ).
		 	\return    ( ENUM_LINE_STYLE).		
		*/        
      ENUM_LINE_STYLE         LevelStyle  (int aIndex)   {return( (ENUM_LINE_STYLE)          ObjectGetInteger(m_id,m_name,OBJPROP_LEVELSTYLE,aIndex));}	

		/*!	
			  OBJPROP_LEVELWIDTH.
         \param   int aIndex -   ( ).
		 	\return    ( int).		
		*/  
      int                     LevelWidth  (int aIndex)   {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_LEVELWIDTH,aIndex));}		

		/*!	
			  OBJPROP_FONTSIZE.
		 	\return    ( int).		
		*/        
      int                     FontSize    ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_FONTSIZE));}		   

		/*!	
			   OBJPROP_RAY_LEFT.
		 	\return   bool. True -   , false -  .		
		*/       
      bool                    RayLeft     ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_RAY_LEFT));} 	

		/*!	
			   OBJPROP_RAY_RIGHT.
		 	\return   bool. True -   , false -  .		
		*/         
      bool                    RayRight    ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_RAY_RIGHT));} 		

		/*!	
			       OBJPROP_RAY.
		 	\return   bool. True -     , false -   .		
		*/   
      bool                    Ray         ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_RAY));} 		

		/*!	
			    " " OBJPROP_ELLIPSE.
      	\return   bool. True -  , false - .		
		*/  
      bool                    Ellipse     ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_ELLIPSE));} 			   

		/*!	
			    "" OBJPROP_ARROWCODE.
      	\return    ( char).
		*/ 
      char                    ArrowCode   ()             {return( (char)                     ObjectGetInteger(m_id,m_name,OBJPROP_ARROWCODE));}

		/*!	
			    OBJPROP_TIMEFRAMES.
      	\return     ( long).
		*/ 
      long                    TimeFrames  ()             {return(                            ObjectGetInteger(m_id,m_name,OBJPROP_TIMEFRAMES));}

		/*!	
			   OBJPROP_ANCHOR.
      	\return     ( long).  OBJ_ARROW    ENUM_ARROW_ANCHOR,  OBJ_LABEL  OBJ_TEXT -    ENUM_ANCHORPOINT.
		*/       
      long                    Anchor      ()             {return(                            ObjectGetInteger(m_id,m_name,OBJPROP_ANCHOR));}

		/*!	
			     X    OBJPROP_XDISTANCE.
      	\return   ( int).
		*/      
      int                     XDistance   ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_XDISTANCE));}	

		/*!	
			     Y    OBJPROP_YDISTANCE.
      	\return   ( int).
		*/        
      int                     YDistanse   ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_YDISTANCE));}	

		/*!	
			   OBJPROP_DIRECTION.
      	\return   ( ENUM_GANN_DIRECTION).
		*/   
      ENUM_GANN_DIRECTION     Direction   ()             {return( (ENUM_GANN_DIRECTION)      ObjectGetInteger(m_id,m_name,OBJPROP_DIRECTION));}

		/*!	
			    OBJPROP_DEGREE.
      	\return   ( ENUM_ELLIOT_WAVE_DEGREE).
		*/        
      ENUM_ELLIOT_WAVE_DEGREE Degree      ()             {return( (ENUM_ELLIOT_WAVE_DEGREE)  ObjectGetInteger(m_id,m_name,OBJPROP_DEGREE));}

		/*!	
			      OBJPROP_DRAWLINES.
      	\return   bool. True - , false - .		
		*/  
      bool                    DrawLines   ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_DRAWLINES));} 

		/*!	
			  (/) OBJPROP_STATE.
      	\return   bool. True - , false - .
		*/ 
      bool                    State       ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_STATE));} 

		/*!	
			  "" OBJPROP_CHART_ID.
      	\return    ( long).
		*/ 
      long                    ChartChartID()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_CHART_ID));}

		/*!	
			   OBJPROP_XSIZE.
      	\return    ( int).
		*/       
      int                     XSize       ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_XSIZE));}	

		/*!	
			   OBJPROP_YSIZE.
      	\return    ( int).
		*/ 
      int                     YSize       ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_YSIZE));}		

		/*!	
			 X     OBJPROP_XOFFSET.
      	\return   ( int).
		*/ 
      int                     XOffset     ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_XOFFSET));}	

		/*!	
			 Y     OBJPROP_YOFFSET.
      	\return   ( int).
		*/ 
      int                     YOffset     ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_YOFFSET));}	

		/*!	
			  "" OBJPROP_PERIOD.
      	\return   ( ENUM_TIMEFRAMES).
		*/       
      ENUM_TIMEFRAMES         Period      ()             {return( (ENUM_TIMEFRAMES)          ObjectGetInteger(m_id,m_name,OBJPROP_PERIOD));}

		/*!	
			      "" OBJPROP_DATE_SCALE.
      	\return   bool. True -  , false -  .
		*/ 
      bool                    DateScale   ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_DATE_SCALE));} 

		/*!	
			      "" OBJPROP_PRICE_SCALE.
      	\return   bool. True -  , false -  .
		*/       
      bool                    PriceScale  ()             {return( (bool)                     ObjectGetInteger(m_id,m_name,OBJPROP_PRICE_SCALE));} 

		/*!	
			   "" OBJPROP_CHART_SCALE.
      	\return   1-5 ( int).
		*/        
      int                     ChartScale  ()             {return( (int)                      ObjectGetInteger(m_id,m_name,OBJPROP_CHART_SCALE));}		

		/*!	
			  OBJPROP_BGCOLOR.
		 	\return    ( color).		
		*/  
      color                   BgColor     ()             {return( (color)                    ObjectGetInteger(m_id,m_name,OBJPROP_BGCOLOR));}

		/*!	
			      OBJPROP_CORNER.
		 	\return   ( ENUM_BASE_CORNER).
		*/  
      ENUM_BASE_CORNER        Corner      ()             {return( (ENUM_BASE_CORNER)         ObjectGetInteger(m_id,m_name,OBJPROP_CORNER));}

		/*!	
			    " " OBJPROP_BORDER_TYPE.
		 	\return   ( ENUM_BORDER_TYPE).
		*/        
      ENUM_BORDER_TYPE        BorderType  ()             {return( (ENUM_BORDER_TYPE)         ObjectGetInteger(m_id,m_name,OBJPROP_BORDER_TYPE));}

		/*!	
			  OBJPROP_PRICE.
         \param   int aIndex -   ( ).
		 	\return   ( double).
		*/    
      double                  Price       (int aIndex)   {return(                            ObjectGetDouble(m_id,m_name,OBJPROP_PRICE,aIndex));} 

		/*!	
			  OBJPROP_LEVELVALUE.
         \param   int aIndex -   ( ).
		 	\return   ( double).
		*/          
      double                  LevelValue  (int aIndex)   {return(                            ObjectGetDouble(m_id,m_name,OBJPROP_LEVELVALUE,aIndex));}  

		/*!	
			 (     " ") OBJPROP_SCALE.
		 	\return   ( double).
		*/        
      double                  Scale       ()             {return(                            ObjectGetDouble(m_id,m_name,OBJPROP_SCALE));}

		/*!	
			 OBJPROP_ANGLE.
		 	\return   ( double).
		*/ 
      double                  Angle       ()             {return(                            ObjectGetDouble(m_id,m_name,OBJPROP_ANGLE));}

		/*!	
			     OBJPROP_DEVIATION.
		 	\return   ( double).
		*/       
      double                  Deviation   ()             {return(                            ObjectGetDouble(m_id,m_name,OBJPROP_DEVIATION));}

		/*!	
			    OBJPROP_TEXT.
		 	\return  .
		*/  
      string                  Text        ()             {return(                            ObjectGetString(m_id,m_name,OBJPROP_TEXT));}

		/*!	
			  . OBJPROP_TOOLTIP.
		 	\return  .
		*/  
      string                  ToolTip     ()             {return(                            ObjectGetString(m_id,m_name,OBJPROP_TOOLTIP));}

		/*!	
			 . OBJPROP_LEVELTEXT.
         \param   int aIndex -   ( ).			
		 	\return  .
		*/        
      string                  LevelText   (int aIndex)   {return(                            ObjectGetString(m_id,m_name,OBJPROP_LEVELTEXT,aIndex));} 

		/*!	
			 . OBJPROP_FONT.
		 	\return   ( string).
		*/       
      string                  Font        ()             {return(                            ObjectGetString(m_id,m_name,OBJPROP_FONT));}

		/*!	
			     "" OBJPROP_BMPFILE,  0.
		 	\return    ( string).
		*/       
      string                  BmpFileOn   ()             {return(                            ObjectGetString(m_id,m_name,OBJPROP_BMPFILE,0));}

		/*!	
			     "" OBJPROP_BMPFILE,  1.
		 	\return    ( string).
		*/    
      string                  BmpFileOff  ()             {return(                            ObjectGetString(m_id,m_name,OBJPROP_BMPFILE,1));}       

		/*!	
			   "" OBJPROP_SYMBOL.
		 	\return   ( string).
		*/  
      string                  Symbol      ()             {return(                            ObjectGetString(m_id,m_name,OBJPROP_SYMBOL));}  
      
      //+------------------------------------------------------------------+
      //|                             |
      //+------------------------------------------------------------------+    

		/*!	
			  OBJPROP_COLOR.
         \param		color aValue -  .			
		*/  
      void SetColor        (color aValue)                      {ObjectSetInteger(m_id,m_name,OBJPROP_COLOR,             aValue);}

		/*!	
			  OBJPROP_STYLE.
         \param		ENUM_LINE_STYLE aValue -  .			
		*/
      void SetStyle        (ENUM_LINE_STYLE aValue)            {ObjectSetInteger(m_id,m_name,OBJPROP_STYLE,             aValue);}

		/*!	
			  OBJPROP_WIDTH.
         \param		int aValue -  .			
		*/  
      void SetWidth        (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_WIDTH,             aValue);} 

		/*!	
			   /  OBJPROP_BACK.
         \param		bool aValue - true/false (/ ).
		*/        
      void SetBack         (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_BACK,              aValue);} 	

		/*!	
			  OBJPROP_FILL.
         \param		bool aValue - true/false (/).
		*/       
      void SetFill         (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_FILL,              aValue);} 		

		/*!	
			  OBJPROP_SELECTED.
         \param		bool aValue - true/false (/ ).
		*/         
      void SetSelected     (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_SELECTED,          aValue);} 		

		/*!	
			      " " OBJPROP_READONLY.
         \param		bool aValue - true/false (/).
		*/         
      void SetReadOnly     (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_READONLY,          aValue);} 		

		/*!	
			      OBJPROP_TIME.
         \param		int aIndex -   ( ),
         \param		datetime aValue -  .
		*/    
      void SetTime         (int aIndex,datetime aValue)        {ObjectSetInteger(m_id,m_name,OBJPROP_TIME,              aIndex,aValue);}	

		/*!	
			    OBJPROP_SELECTABLE.
         \param		bool aValue - true/false (/).
		*/       
      void SetSelectable   (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_SELECTABLE,        aValue);} 		

		/*!	
			   OBJPROP_LEVELS.
         \param		int aValue -  .
		*/       
      void SetLevels       (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_LEVELS,            aValue);}	

		/*!	
			   OBJPROP_LEVELCOLOR.
         \param   int aIndex -   ( ),
         \param   color aValue -  .
		*/        
      void SetLevelColor   (int aIndex,color aValue)           {ObjectSetInteger(m_id,m_name,OBJPROP_LEVELCOLOR,        aIndex,aValue);}		

		/*!	
			   OBJPROP_LEVELSTYLE.
         \param   int aIndex -   ( ),
         \param   ENUM_LINE_STYLE aValue -  .
		*/  
      void SetLevelStyle   (int aIndex,ENUM_LINE_STYLE aValue) {ObjectSetInteger(m_id,m_name,OBJPROP_LEVELSTYLE,        aIndex,aValue);}

		/*!	
			   OBJPROP_LEVELWIDTH.
         \param   int aIndex -   ( ),
         \param   int aValue -  .
		*/  
      void SetLevelWidth   (int aIndex,int aValue)             {ObjectSetInteger(m_id,m_name,OBJPROP_LEVELWIDTH,        aIndex,aValue);}		

		/*!	
			   OBJPROP_FONTSIZE.
         \param   int aValue -  .
		*/  
      void SetFontSize     (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_FONTSIZE,          aValue);}		   

		/*!	
			   OBJPROP_RAY_LEFT.
         \param   bool aValue - true/false (/).
		*/  
      void SetRayLeft      (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_RAY_LEFT,          aValue);} 	

		/*!	
			   OBJPROP_RAY_RIGHT.
         \param   bool aValue - true/false (/).
		*/        
      void SetRayRight     (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_RAY_RIGHT,         aValue);} 		

		/*!	
			      OBJPROP_RAY.
         \param   bool aValue - true/false (/).
		*/   
      void SetRay          (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_RAY,               aValue);} 		

		/*!	
			   " "   OBJPROP_ELLIPSE.
         \param   bool aValue - true/false (/).
		*/        
      void SetEllipse      (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_ELLIPSE,           aValue);} 			   

		/*!	
			   OBJPROP_ARROWCODE.
         \param   char aValue -  .
		*/        
      void SetArrowCode    (char aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_ARROWCODE,         aValue);}

		/*!	
			     OBJPROP_TIMEFRAMES.
         \param   long aValue -   .
		*/           
      void SetTimeFrames   (long aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_TIMEFRAMES,        aValue);}

		/*!	
			   OBJPROP_ANCHOR.
         \param   long aValue -   (ENUM_ARROW_ANCHOR  ENUM_ANCHORPOINT).
		*/    
      void SetAnchor       (long aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_ANCHOR,            aValue);}

		/*!	
			    X    OBJPROP_XDISTANCE.
         \param   int aValue -  .
		*/    
      void SetXDistance    (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_XDISTANCE,         aValue);}	

		/*!	
			    Y    OBJPROP_YDISTANCE.
         \param   int aValue -  .
		*/          
      void SetYDistanse    (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_YDISTANCE,         aValue);}	

		/*!	
			    OBJPROP_DIRECTION.
         \param   ENUM_GANN_DIRECTION aValue -  .
		*/ 
      void SetDirection    (ENUM_GANN_DIRECTION aValue)        {ObjectSetInteger(m_id,m_name,OBJPROP_DIRECTION,         aValue);}

		/*!	
			     OBJPROP_DEGREE.
         \param   ENUM_ELLIOT_WAVE_DEGREE aValue -  .
		*/ 
      void SetDegree       (ENUM_ELLIOT_WAVE_DEGREE aValue)    {ObjectSetInteger(m_id,m_name,OBJPROP_DEGREE,            aValue);}

		/*!	
			      OBJPROP_DRAWLINES.
         \param   bool aValue - true/false (/).
		*/       
      void SetDrawLines    (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_DRAWLINES,         aValue);} 

		/*!	
			  .
         \param   bool aValue - true/false (/).
		*/        
      void SetState        (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_STATE,             aValue);} 

		/*!	
			   OBJPROP_XSIZE.
         \param   int aValue -  .
		*/       
      void SetXSize        (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_XSIZE,             aValue);}	

		/*!	
			   OBJPROP_YSIZE.
         \param   int aValue -  .
		*/          
      void SetYSize        (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_YSIZE,             aValue);}		

		/*!	
			  X    OBJPROP_XOFFSET.
         \param   int aValue -  .
		*/ 
      void SetXOffset      (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_XOFFSET,           aValue);}	

		/*!	
			  Y    OBJPROP_YOFFSET.
         \param   int aValue -  .
		*/ 
      void SetYOffset      (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_YOFFSET,           aValue);}	

		/*!	
			   "" OBJPROP_PERIOD.
         \param   ENUM_TIMEFRAMES aValue -  .
		*/ 
      void SetPeriod       (ENUM_TIMEFRAMES aValue)            {ObjectSetInteger(m_id,m_name,OBJPROP_PERIOD,            aValue);}

		/*!	
			/     "" OBJPROP_DATE_SCALE.
         \param   bool aValue - true/false (/).
		*/ 
      void SetDateScale    (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_DATE_SCALE,        aValue);} 

		/*!	
			/     "" OBJPROP_PRICE_SCALE.
         \param   bool aValue - true/false (/).
		*/       
      void SetPriceScale   (bool aValue)                       {ObjectSetInteger(m_id,m_name,OBJPROP_PRICE_SCALE,       aValue);} 

		/*!	
			    "" OBJPROP_CHART_SCALE.
         \param   int aValue -  1-5.
		*/         
      void SetChartScale   (int aValue)                        {ObjectSetInteger(m_id,m_name,OBJPROP_CHART_SCALE,       aValue);}		

		/*!	
			   OBJPROP_BGCOLOR.
         \param   color aValue -  .
		*/        
      void SetBgColor      (color aValue)                      {ObjectSetInteger(m_id,m_name,OBJPROP_BGCOLOR,           aValue);}

		/*!	
			     OBJPROP_CORNER.
         \param   ENUM_BASE_CORNER aValue -  .
		*/       
      void SetCorner       (ENUM_BASE_CORNER aValue)           {ObjectSetInteger(m_id,m_name,OBJPROP_CORNER,            aValue);}

		/*!	
			     " " OBJPROP_BORDER_TYPE.
         \param   ENUM_BORDER_TYPE aValue -  .
		*/        
      void SetBorderType   (ENUM_BORDER_TYPE aValue)           {ObjectSetInteger(m_id,m_name,OBJPROP_BORDER_TYPE,       aValue);}      

		/*!	
			   OBJPROP_PRICE.
         \param   int aIndex -   ( ),
		 	\param  double aValue - .
		*/   
      void SetPrice        (int aIndex,double aValue)          {ObjectSetDouble(m_id,m_name,OBJPROP_PRICE,              aIndex,aValue);} 

		/*!	
			   OBJPROP_LEVELVALUE.
         \param   int aIndex -   ( ),
		 	\param  double aValue - .
		*/        
      void SetLevelValue   (int aIndex,double aValue)          {ObjectSetDouble(m_id,m_name,OBJPROP_LEVELVALUE,         aIndex,aValue);}  

		/*!	
			  (     " ") OBJPROP_SCALE.
		 	\param  double aValue -  .
		*/       
      void SetScale        (double aValue)                     {ObjectSetDouble(m_id,m_name,OBJPROP_SCALE,              aValue);}     

		/*!	
			  OBJPROP_ANGLE.
		 	\param  double aValue -   OBJPROP_ANGLE.
		*/       
      void SetAngle        (double aValue)                     {ObjectSetDouble(m_id,m_name,OBJPROP_ANGLE,              aValue);}

		/*!	
			     OBJPROP_DEVIATION.
		 	\param  double aValue -   (  ).
		*/         
      void SetDeviation    (double aValue)                     {ObjectSetDouble(m_id,m_name,OBJPROP_DEVIATION,          aValue);}

		/*!	
			  OBJPROP_TEXT.
		 	\param  string aValue - .
		*/   
      void SetText         (string aValue)                     {ObjectSetString(m_id,m_name,OBJPROP_TEXT,               aValue);}

		/*!	
			   OBJPROP_TOOLTIP.
		 	\param  string aValue - .
		 	\remark      "\n".		 	
		*/       
      void SetToolTip      (string aValue)                     {ObjectSetString(m_id,m_name,OBJPROP_TOOLTIP,            aValue);}

		/*!	
			   OBJPROP_LEVELTEXT.
         \param   int aIndex -   ( ),
		 	\param  string aValue - . 	
		*/       
      void SetLevelText    (int aIndex,string aValue)          {ObjectSetString(m_id,m_name,OBJPROP_LEVELTEXT,          aIndex,aValue);} 

		/*!	
			   OBJPROP_FONT.
		 	\param  string aValue -  . 	
		*/        
      void SetFont         (string aValue)                     {ObjectSetString(m_id,m_name,OBJPROP_FONT,               aValue);} 

		/*!	
			     "" OBJPROP_BMPFILE,  0.
		 	\param  string aValue -  . 	
		*/         
      void SetBmpFileOn    (string aValue)                     {ObjectSetString(m_id,m_name,OBJPROP_BMPFILE,            0,aValue);}       

		/*!	
			     "" OBJPROP_BMPFILE,  1.
		 	\param  string aValue -  . 	
		*/        
      void SetBmpFileOff   (string aValue)                     {ObjectSetString(m_id,m_name,OBJPROP_BMPFILE,            1,aValue);}       

		/*!	
			    "" OBJPROP_SYMBOL.
		 	\param  string aValue - . 	
		*/      
      void SetSymbol       (string aValue)                     {ObjectSetString(m_id,m_name,OBJPROP_SYMBOL,             aValue);}  
      
      //+------------------------------------------------------------------+
      //|                                    |
      //+------------------------------------------------------------------+         
   
		/*!	
			 OBJPROP_COLOR.
			\param  string aName -   . 
		 	\return    ( color).		
		*/     
      color                   Color       (string aName)             {return( (color)                    ObjectGetInteger(0,aName,OBJPROP_COLOR));}
		
		/*!	
			 OBJPROP_STYLE.
         \param  string aName -   . 			
		 	\return    ( ENUM_LINE_STYLE).		
		*/        
      ENUM_LINE_STYLE         Style       (string aName)             {return( (ENUM_LINE_STYLE)          ObjectGetInteger(0,aName,OBJPROP_STYLE));}
		
		/*!	
			 OBJPROP_WIDTH.
         \param  string aName -   . 						
		 	\return    ( int).		
		*/  
      int                     Width       (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_WIDTH));} 
		
		/*!	
			     OBJPROP_BACK.
         \param  string aName -   . 			
		 	\return   bool. True -   , false -  .		
		*/    
      bool                    Back        (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_BACK));} 	
		
		/*!	
			   OBJPROP_FILL ( OBJ_RECTANGLE, OBJ_TRIANGLE, OBJ_ELLIPSE, OBJ_CHANNEL, OBJ_STDDEVCHANNEL, OBJ_REGRESSION)
         \param  string aName -   . 			
		 	\return   bool. True - , false - .	
		*/  
      bool                    Fill        (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_FILL));} 		
		
		/*!	
			  OBJPROP_SELECTED.
         \param  string aName -   . 			
		 	\return   bool. True - , false -  .	
		*/  
      bool                    Selected    (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_SELECTED));} 		
		
		/*!	
			     " " OBJPROP_SELECTED.
         \param  string aName -   . 			
		 	\return   bool. True -  , false - .	
		*/  
      bool                    ReadOnly    (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_READONLY));} 		
		
		/*!	
			  OBJPROP_TYPE.
         \param  string aName -   . 			
		 	\return   ENUM_OBJECT.	
		*/  
      ENUM_OBJECT             Type        (string aName)             {return( (ENUM_OBJECT)              ObjectGetInteger(0,aName,OBJPROP_TYPE));}
		
		/*!	
			      OBJPROP_TIME.
         \param  string aName -   ,
         \param   int aIndex -    ( ).
		 	\return    ( datetime).		
		*/  
      datetime                Time        (string aName,int aIndex)  {return( (datetime)                 ObjectGetInteger(0,aName,OBJPROP_TIME,aIndex));}	
		
		/*!	
			   OBJPROP_SELECTABLE.
         \param  string aName -   . 			
		 	\return   bool. True -  , false - .	
		*/   
      bool                    Selectable  (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_SELECTABLE));} 		
		
		/*!	
			   OBJPROP_CREATETIME.
         \param  string aName -   . 						
		 	\return    ( datetime).		
		*/  
      datetime                CreateTime  (string aName)             {return( (datetime)                 ObjectGetInteger(0,aName,OBJPROP_CREATETIME));}	
		
		/*!	
			  OBJPROP_LEVELS).
         \param  string aName -   . 						
		 	\return   ( int).		
		*/   
      int                     Levels      (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_LEVELS));}	
		
		/*!	
			  OBJPROP_LEVELCOLOR.
         \param   int aIndex -   ( ).
         \param  string aName -   . 			         
		 	\return    ( color).		
		*/ 
      color                   LevelColor  (string aName,int aIndex)  {return( (color)                    ObjectGetInteger(0,aName,OBJPROP_LEVELCOLOR,aIndex));}		
		
		/*!	
			  OBJPROP_LEVELSTYLE.
         \param   int aIndex -   ( ).
         \param  string aName -   . 			         
		 	\return    ( ENUM_LINE_STYLE).		
		*/  
      ENUM_LINE_STYLE         LevelStyle  (string aName,int aIndex)  {return( (ENUM_LINE_STYLE)          ObjectGetInteger(0,aName,OBJPROP_LEVELSTYLE,aIndex));}	
		
		/*!	
			  OBJPROP_LEVELWIDTH.
         \param   int aIndex -   ( ).
         \param  string aName -   . 			         
		 	\return    ( int).		
		*/  
      int                     LevelWidth  (string aName,int aIndex)  {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_LEVELWIDTH,aIndex));}		
		
		/*!	
			  OBJPROP_FONTSIZE.
         \param  string aName -   . 						
		 	\return    ( int).		
		*/  
      int                     FontSize    (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_FONTSIZE));}		   
		
		/*!	
			   OBJPROP_RAY_LEFT.
         \param  string aName -   . 						
		 	\return   bool. True -   , false -  .		
		*/    
      bool                    RayLeft     (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_RAY_LEFT));} 	
		
		/*!	
			   OBJPROP_RAY_RIGHT.
         \param  string aName -   . 						
		 	\return   bool. True -   , false -  .		
		*/  
      bool                    RayRight    (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_RAY_RIGHT));} 		
		
		/*!	
			       OBJPROP_RAY.
         \param  string aName -   . 						
		 	\return   bool. True -     , false -   .		
		*/  
      bool                    Ray         (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_RAY));} 		
		
		/*!	
			    " " OBJPROP_ELLIPSE.
         \param  string aName -   . 						
      	\return   bool. True -  , false - .		
		*/ 
      bool                    Ellipse     (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_ELLIPSE));} 			   
		
		/*!	
			    "" OBJPROP_ARROWCODE.
         \param  string aName -   . 						
      	\return    ( char).
		*/ 
      char                    ArrowCode   (string aName)             {return( (char)                     ObjectGetInteger(0,aName,OBJPROP_ARROWCODE));}
		
		/*!	
			    OBJPROP_TIMEFRAMES.
         \param  string aName -   . 						
      	\return     ( long).
		*/ 
      long                    TimeFrames  (string aName)             {return(                            ObjectGetInteger(0,aName,OBJPROP_TIMEFRAMES));}
		
		/*!	
			   OBJPROP_ANCHOR.
         \param  string aName -   . 						
      	\return     ( long).  OBJ_ARROW    ENUM_ARROW_ANCHOR,  OBJ_LABEL  OBJ_TEXT -    ENUM_ANCHORPOINT.
		*/   
      long                    Anchor      (string aName)             {return(                            ObjectGetInteger(0,aName,OBJPROP_ANCHOR));}
		
		/*!	
			     X    OBJPROP_XDISTANCE.
         \param  string aName -   . 						
      	\return   ( int).
		*/ 
      int                     XDistance   (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_XDISTANCE));}	
		
		/*!	
			     Y    OBJPROP_YDISTANCE.
         \param  string aName -   . 						
      	\return   ( int).
		*/  
      int                     YDistanse   (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_YDISTANCE));}	
		
		/*!	
			   OBJPROP_DIRECTION.
         \param  string aName -   . 						
      	\return   ( ENUM_GANN_DIRECTION).
		*/   
      ENUM_GANN_DIRECTION     Direction   (string aName)             {return( (ENUM_GANN_DIRECTION)      ObjectGetInteger(0,aName,OBJPROP_DIRECTION));}
		
		/*!	
			    OBJPROP_DEGREE.
         \param  string aName -   . 						
      	\return   ( ENUM_ELLIOT_WAVE_DEGREE).
		*/   
      ENUM_ELLIOT_WAVE_DEGREE Degree      (string aName)             {return( (ENUM_ELLIOT_WAVE_DEGREE)  ObjectGetInteger(0,aName,OBJPROP_DEGREE));}
		
		/*!	
			      OBJPROP_DRAWLINES.
         \param  string aName -   . 						
      	\return   bool. True - , false - .		
		*/  
      bool                    DrawLines   (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_DRAWLINES));} 
		
		/*!	
			  (/) OBJPROP_STATE.
         \param  string aName -   . 						
      	\return   bool. True - , false - .
		*/ 
      bool                    State       (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_STATE));} 
		
		/*!	
			  "" OBJPROP_CHART_ID.
         \param  string aName -   . 						
      	\return    ( long).
		*/ 
      long                    ChartChartID(string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_CHART_ID));}
		
		/*!	
			   OBJPROP_XSIZE.
         \param  string aName -   . 						
      	\return    ( int).
		*/   
      int                     XSize       (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_XSIZE));}	
		
		/*!	
			   OBJPROP_YSIZE.
         \param  string aName -   . 						
      	\return    ( int).
		*/ 
      int                     YSize       (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_YSIZE));}		
		
		/*!	
			 X     OBJPROP_XOFFSET.
         \param  string aName -   . 						
      	\return   ( int).
		*/ 
      int                     XOffset     (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_XOFFSET));}	
		
		/*!	
			 Y     OBJPROP_YOFFSET.
         \param  string aName -   . 						
      	\return   ( int).
		*/ 
      int                     YOffset     (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_YOFFSET));}	
		
		/*!	
			  "" OBJPROP_PERIOD.
         \param  string aName -   . 						
      	\return   ( ENUM_TIMEFRAMES).
		*/  
      ENUM_TIMEFRAMES         Period      (string aName)             {return( (ENUM_TIMEFRAMES)          ObjectGetInteger(0,aName,OBJPROP_PERIOD));}
		
		/*!	
			      "" OBJPROP_DATE_SCALE.
         \param  string aName -   . 						
      	\return   bool. True -  , false -  .
		*/ 
      bool                    DateScale   (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_DATE_SCALE));} 
		
		/*!	
			      "" OBJPROP_PRICE_SCALE.
         \param  string aName -   . 						
      	\return   bool. True -  , false -  .
		*/  
      bool                    PriceScale  (string aName)             {return( (bool)                     ObjectGetInteger(0,aName,OBJPROP_PRICE_SCALE));} 
		
		/*!	
			   "" OBJPROP_CHART_SCALE.
         \param  string aName -   . 						
      	\return   1-5 ( int).
		*/  
      int                     ChartScale  (string aName)             {return( (int)                      ObjectGetInteger(0,aName,OBJPROP_CHART_SCALE));}		
		
		/*!	
			  OBJPROP_BGCOLOR.
         \param  string aName -   . 						
		 	\return    ( color).		
		*/  
      color                   BgColor     (string aName)             {return( (color)                    ObjectGetInteger(0,aName,OBJPROP_BGCOLOR));}
		
		/*!	
			      OBJPROP_CORNER.
         \param  string aName -   . 						
		 	\return   ( ENUM_BASE_CORNER).
		*/  
      ENUM_BASE_CORNER        Corner      (string aName)             {return( (ENUM_BASE_CORNER)         ObjectGetInteger(0,aName,OBJPROP_CORNER));}
		
		/*!	
			    " " OBJPROP_BORDER_TYPE.
         \param  string aName -   . 						
		 	\return   ( ENUM_BORDER_TYPE).
		*/   
      ENUM_BORDER_TYPE        BorderType  (string aName)             {return( (ENUM_BORDER_TYPE)         ObjectGetInteger(0,aName,OBJPROP_BORDER_TYPE));}
		
		/*!	
			  OBJPROP_PRICE.
         \param  string aName -   ,			
         \param   int aIndex -   ( ).
		 	\return   ( double).
		*/   
      double                  Price       (string aName,int aIndex)  {return(                            ObjectGetDouble(0,aName,OBJPROP_PRICE,aIndex));} 
		
		/*!	
			  OBJPROP_LEVELVALUE.
         \param  string aName -   ,			
         \param   int aIndex -   ( ).
		 	\return   ( double).
		*/     
      double                  LevelValue  (string aName,int aIndex)  {return(                            ObjectGetDouble(0,aName,OBJPROP_LEVELVALUE,aIndex));}  
		
		/*!	
			 (     " ") OBJPROP_SCALE.
         \param  string aName -   . 						
		 	\return   ( double).
		*/   
      double                  Scale       (string aName)             {return(                            ObjectGetDouble(0,aName,OBJPROP_SCALE));}
		
		/*!	
			 OBJPROP_ANGLE.
         \param  string aName -   . 						
		 	\return   ( double).
		*/ 
      double                  Angle       (string aName)             {return(                            ObjectGetDouble(0,aName,OBJPROP_ANGLE));}
		
		/*!	
			     OBJPROP_DEVIATION.
         \param  string aName -   . 						
		 	\return   ( double).
		*/  
      double                  Deviation   (string aName)             {return(                            ObjectGetDouble(0,aName,OBJPROP_DEVIATION));}
		
		/*!	
			    OBJPROP_TEXT.
         \param  string aName -   . 						
		 	\return  .
		*/  
      string                  Text        (string aName)             {return(                            ObjectGetString(0,aName,OBJPROP_TEXT));}
		
		/*!	
			  . OBJPROP_TOOLTIP.
         \param  string aName -   . 						
		 	\return  .
		 	\remark      "\n".
		*/  
      string                  ToolTip     (string aName)             {return(                            ObjectGetString(0,aName,OBJPROP_TOOLTIP));}
		
		/*!	
			 . OBJPROP_LEVELTEXT.
         \param  string aName -   ,		
         \param   int aIndex -   ( ).			
		 	\return  .
		*/   
      string                  LevelText   (string aName,int aIndex)  {return(                            ObjectGetString(0,aName,OBJPROP_LEVELTEXT,aIndex));} 
		
		/*!	
			 . OBJPROP_FONT.
         \param  string aName -   . 						
		 	\return   ( string).
		*/   
      string                  Font        (string aName)             {return(                            ObjectGetString(0,aName,OBJPROP_FONT));}
		
		/*!	
			     "" OBJPROP_BMPFILE,  0.
         \param  string aName -   . 						
		 	\return    ( string).
		*/   
      string                  BmpFileOn   (string aName)             {return(                            ObjectGetString(0,aName,OBJPROP_BMPFILE,0));}
		
		/*!	
			     "" OBJPROP_BMPFILE,  1.
         \param  string aName -   . 						
		 	\return    ( string).
		*/    
      string                  BmpFileOff  (string aName)             {return(                            ObjectGetString(0,aName,OBJPROP_BMPFILE,1));}       
		
		/*!	
			   "" OBJPROP_SYMBOL.
         \param  string aName -   . 						
		 	\return   ( string).
		*/  
      string                  Symbol      (string aName)             {return(                            ObjectGetString(0,aName,OBJPROP_SYMBOL));}  

      //+------------------------------------------------------------------+
      //|       .                            |
      //+------------------------------------------------------------------+          
      
		/*!	
			  OBJPROP_COLOR.
			\param  string aName -   ,
         \param		color aValue -  .			
		*/  
      void SetColor        (string aName,color aValue)                        {ObjectSetInteger(0,aName,OBJPROP_COLOR,           aValue);}

		/*!	
			  OBJPROP_STYLE.
			\param  string aName -   ,
         \param		ENUM_LINE_STYLE aValue -  .			
		*/
      void SetStyle        (string aName,ENUM_LINE_STYLE aValue)              {ObjectSetInteger(0,aName,OBJPROP_STYLE,           aValue);}

		/*!	
			  OBJPROP_WIDTH.
			\param  string aName -   ,
         \param		int aValue -  .			
		*/ 
      void SetWidth        (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_WIDTH,           aValue);} 

		/*!	
			   /  OBJPROP_BACK.
			\param  string aName -   ,
         \param		bool aValue - true/false (/ ).
		*/   
      void SetBack         (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_BACK,            aValue);} 	

		/*!	
			  OBJPROP_FILL.
			\param  string aName -   ,
         \param		bool aValue - true/false (/).
		*/ 
      void SetFill         (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_FILL,            aValue);} 		

		/*!	
			  OBJPROP_SELECTED.
			\param  string aName -   ,
         \param		bool aValue - true/false (/ ).
		*/ 
      void SetSelected     (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_SELECTED,        aValue);} 		

		/*!	
			      " " OBJPROP_READONLY.
			\param  string aName -   ,
         \param		bool aValue - true/false (/).
		*/  
      void SetReadOnly     (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_READONLY,        aValue);} 		

		/*!	
			      OBJPROP_TIME.
         \param		int aIndex -   ( ),
         \param  string aName -   ,
         \param		datetime aValue -  .
		*/    
      void SetTime         (string aName,int aIndex,datetime aValue)          {ObjectSetInteger(0,aName,OBJPROP_TIME,            aIndex,aValue);}	

		/*!	
			    OBJPROP_SELECTABLE.
			\param  string aName -   ,
         \param		bool aValue - true/false (/).
		*/ 
      void SetSelectable   (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_SELECTABLE,      aValue);} 		

		/*!	
			   OBJPROP_LEVELS.
			\param  string aName -   ,
         \param		int aValue -  .
		*/  
      void SetLevels       (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_LEVELS,          aValue);}	

		/*!	
			   OBJPROP_LEVELCOLOR.
			\param  string aName -   ,
         \param   int aIndex -   ( ),
         \param   color aValue -  .
		*/   
      void SetLevelColor   (string aName,int aIndex,color aValue)             {ObjectSetInteger(0,aName,OBJPROP_LEVELCOLOR,      aIndex,aValue);}		

		/*!	
			   OBJPROP_LEVELSTYLE.
			\param  string aName -   ,
         \param   int aIndex -   ( ),
         \param   ENUM_LINE_STYLE aValue -  .
		*/  
      void SetLevelStyle   (string aName,int aIndex,ENUM_LINE_STYLE aValue)   {ObjectSetInteger(0,aName,OBJPROP_LEVELSTYLE,      aIndex,aValue);}

		/*!	
			   OBJPROP_LEVELWIDTH.
			\param  string aName -   ,
         \param   int aIndex -   ( ),
         \param   int aValue -  .
		*/  
      void SetLevelWidth   (string aName,int aIndex,int aValue)               {ObjectSetInteger(0,aName,OBJPROP_LEVELWIDTH,      aIndex,aValue);}		

		/*!	
			   OBJPROP_FONTSIZE.
			\param  string aName -   ,
         \param   int aValue -  .
		*/  
      void SetFontSize     (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_FONTSIZE,        aValue);}		   

		/*!	
			   OBJPROP_RAY_LEFT.
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/    
      void SetRayLeft      (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_RAY_LEFT,        aValue);} 	

		/*!	
			   OBJPROP_RAY_RIGHT.
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/  
      void SetRayRight     (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_RAY_RIGHT,       aValue);} 		

		/*!	
			      OBJPROP_RAY.
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/   
      void SetRay          (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_RAY,             aValue);} 		

		/*!	
			   " "   OBJPROP_ELLIPSE.
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetEllipse      (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_ELLIPSE,         aValue);} 			   

		/*!	
			   OBJPROP_ARROWCODE.
			\param  string aName -   ,
         \param   char aValue -  .
		*/ 
      void SetArrowCode    (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_ARROWCODE,       aValue);}

		/*!	
			     OBJPROP_TIMEFRAMES.
			\param  string aName -   ,
         \param   long aValue -   .
		*/   
      void SetTimeFrames   (string aName,long aValue)                         {ObjectSetInteger(0,aName,OBJPROP_TIMEFRAMES,      aValue);}

		/*!	
			   OBJPROP_ANCHOR.
			\param  string aName -   ,
         \param   long aValue -   (ENUM_ARROW_ANCHOR  ENUM_ANCHORPOINT).
		*/   
      void SetAnchor       (string aName,long aValue)                         {ObjectSetInteger(0,aName,OBJPROP_ANCHOR,          aValue);}

		/*!	
			    X    OBJPROP_XDISTANCE.
			\param  string aName -   ,
         \param   int aValue -  .
		*/   
      void SetXDistance    (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_XDISTANCE,       aValue);}	

		/*!	
			    Y    OBJPROP_YDISTANCE.
			\param  string aName -   ,
         \param   int aValue -  .
		*/ 
      void SetYDistanse    (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_YDISTANCE,       aValue);}	

		/*!	
			    OBJPROP_DIRECTION.
			\param  string aName -   ,
         \param   ENUM_GANN_DIRECTION aValue -  .
		*/ 
      void SetDirection    (string aName,ENUM_GANN_DIRECTION aValue)          {ObjectSetInteger(0,aName,OBJPROP_DIRECTION,       aValue);}

		/*!	
			     OBJPROP_DEGREE.
			\param  string aName -   ,
         \param   ENUM_ELLIOT_WAVE_DEGREE aValue -  .
		*/ 
      void SetDegree       (string aName,ENUM_ELLIOT_WAVE_DEGREE aValue)      {ObjectSetInteger(0,aName,OBJPROP_DEGREE,          aValue);}

		/*!	
			      OBJPROP_DRAWLINES.
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetDrawLines    (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_DRAWLINES,       aValue);} 

		/*!	
			  .
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/  
      void SetState        (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_STATE,           aValue);} 

		/*!	
			   OBJPROP_XSIZE.
			\param  string aName -   ,
         \param   int aValue -  .
		*/   
      void SetXSize        (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_XSIZE,           aValue);}	

		/*!	
			   OBJPROP_YSIZE.
			\param  string aName -   ,
         \param   int aValue -  .
		*/  
      void SetYSize        (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_YSIZE,           aValue);}		

		/*!	
			  X    OBJPROP_XOFFSET.
			\param  string aName -   ,
         \param   int aValue -  .
		*/ 
      void SetXOffset      (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_XOFFSET,         aValue);}	

		/*!	
			  Y    OBJPROP_YOFFSET.
			\param  string aName -   ,
         \param   int aValue -  .
		*/ 
      void SetYOffset      (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_YOFFSET,         aValue);}	

		/*!	
			   "" OBJPROP_PERIOD.
			\param  string aName -   ,
         \param   ENUM_TIMEFRAMES aValue -  .
		*/ 
      void SetPeriod       (string aName,ENUM_TIMEFRAMES aValue)              {ObjectSetInteger(0,aName,OBJPROP_PERIOD,          aValue);}

		/*!	
			/     "" OBJPROP_DATE_SCALE.
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetDateScale    (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_DATE_SCALE,      aValue);} 

		/*!	
			/     "" OBJPROP_PRICE_SCALE.
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetPriceScale   (string aName,bool aValue)                         {ObjectSetInteger(0,aName,OBJPROP_PRICE_SCALE,     aValue);} 

		/*!	
			    "" OBJPROP_CHART_SCALE.
			\param  string aName -   ,
         \param   int aValue -  1-5.
		*/  
      void SetChartScale   (string aName,int aValue)                          {ObjectSetInteger(0,aName,OBJPROP_CHART_SCALE,     aValue);}		

		/*!	
			   OBJPROP_BGCOLOR.
			\param  string aName -   ,
         \param   color aValue -  .
		*/    
      void SetBgColor      (string aName,color aValue)                        {ObjectSetInteger(0,aName,OBJPROP_BGCOLOR,         aValue);}

		/*!	
			     OBJPROP_CORNER.
			\param  string aName -   ,
         \param   ENUM_BASE_CORNER aValue -  .
		*/  
      void SetCorner       (string aName,ENUM_BASE_CORNER aValue)             {ObjectSetInteger(0,aName,OBJPROP_CORNER,          aValue);}

		/*!	
			     " " OBJPROP_BORDER_TYPE.
			\param  string aName -   ,
         \param   ENUM_BORDER_TYPE aValue -  .
		*/   
      void SetBorderType   (string aName,ENUM_BORDER_TYPE aValue)             {ObjectSetInteger(0,aName,OBJPROP_BORDER_TYPE,     aValue);}      

		/*!	
			   OBJPROP_PRICE.
			\param  string aName -   ,
         \param   int aIndex -   ( ),
		 	\param  double aValue - .
		*/  
      void SetPrice        (string aName,int aIndex,double aValue)            {ObjectSetDouble(0,aName,OBJPROP_PRICE,            aIndex,aValue);} 

		/*!	
			   OBJPROP_LEVELVALUE.
			\param  string aName -   ,
         \param   int aIndex -   ( ),
		 	\param  double aValue - .
		*/  
      void SetLevelValue   (string aName,int aIndex,double aValue)            {ObjectSetDouble(0,aName,OBJPROP_LEVELVALUE,       aIndex,aValue);}  

		/*!	
			  (     " ") OBJPROP_SCALE.
			\param  string aName -   ,
		 	\param  double aValue -  .
		*/ 
      void SetScale        (string aName,double aValue)                       {ObjectSetDouble(0,aName,OBJPROP_SCALE,            aValue);}     

		/*!	
			  OBJPROP_ANGLE.
			\param  string aName -   ,
		 	\param  double aValue -   OBJPROP_ANGLE.
		*/    
      void SetAngle        (string aName,double aValue)                       {ObjectSetDouble(0,aName,OBJPROP_ANGLE,            aValue);}

		/*!	
			     OBJPROP_DEVIATION.
			\param  string aName -   ,
		 	\param  double aValue -   (  ).
		*/   
      void SetDeviation    (string aName,double aValue)                       {ObjectSetDouble(0,aName,OBJPROP_DEVIATION,        aValue);}

		/*!	
			  OBJPROP_TEXT.
			\param  string aName -   ,
		 	\param  string aValue - .
		*/  
      void SetText         (string aName,string aValue)                       {ObjectSetString(0,aName,OBJPROP_TEXT,             aValue);}

		/*!	
			   OBJPROP_TOOLTIP.
			\param  string aName -   ,
		 	\param  string aValue - .
		 	\remark      "\n".		 	
		*/
      void SetToolTip      (string aName,string aValue)                       {ObjectSetString(0,aName,OBJPROP_TOOLTIP,          aValue);}

		/*!	
			   OBJPROP_LEVELTEXT.
			\param  string aName -   ,
         \param   int aIndex -   ( ),
		 	\param  string aValue - . 	
		*/  
      void SetLevelText    (string aName,int aIndex,string aValue)            {ObjectSetString(0,aName,OBJPROP_LEVELTEXT,        aIndex,aValue);} 

		/*!	
			   OBJPROP_FONT.
			\param  string aName -   ,
		 	\param  string aValue -  . 	
		*/ 
      void SetFont         (string aName,string aValue)                       {ObjectSetString(0,aName,OBJPROP_FONT,             aValue);} 

		/*!	
			     "" OBJPROP_BMPFILE,  0.
			\param  string aName -   ,
		 	\param  string aValue -  . 	
		*/  
      void SetBmpFileOn    (string aName,string aValue)                       {ObjectSetString(0,aName,OBJPROP_BMPFILE,          0,aValue);}       

		/*!	
			     "" OBJPROP_BMPFILE,  1.
			\param  string aName -   ,
		 	\param  string aValue -  . 	
		*/  
      void SetBmpFileOff   (string aName,string aValue)                       {ObjectSetString(0,aName,OBJPROP_BMPFILE,          1,aValue);}       

		/*!	
			    "" OBJPROP_SYMBOL.
			\param  string aName -   ,
		 	\param  string aValue - . 	
		*/  
      void SetSymbol       (string aName,string aValue)                       {ObjectSetString(0,aName,OBJPROP_SYMBOL,           aValue);}  
   
      //+------------------------------------------------------------------+
      //|              |
      //+------------------------------------------------------------------+         
      
		/*!	
			 OBJPROP_COLOR.
			\param  long aChartID -  ,
			\param  string aName -   . 
		 	\return    ( color).		
		*/  
      color                   Color       (long aChartID,string aName)             {return( (color)                    ObjectGetInteger(aChartID,aName,OBJPROP_COLOR));}
		
		/*!	
			 OBJPROP_STYLE.
			\param  long aChartID -  ,
         \param  string aName -   . 			
		 	\return    ( ENUM_LINE_STYLE).		
		*/        
      ENUM_LINE_STYLE         Style       (long aChartID,string aName)             {return( (ENUM_LINE_STYLE)          ObjectGetInteger(aChartID,aName,OBJPROP_STYLE));}
		
		/*!	
			 OBJPROP_WIDTH.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return    ( int).		
		*/        
      int                     Width       (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_WIDTH));} 
		
		/*!	
			     OBJPROP_BACK.
			\param  long aChartID -  ,
         \param  string aName -   . 			
		 	\return   bool. True -   , false -  .		
		*/          
      bool                    Back        (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_BACK));} 	
		
		/*!	
			   OBJPROP_FILL ( OBJ_RECTANGLE, OBJ_TRIANGLE, OBJ_ELLIPSE, OBJ_CHANNEL, OBJ_STDDEVCHANNEL, OBJ_REGRESSION)
			\param  long aChartID -  ,
         \param  string aName -   . 			
		 	\return   bool. True - , false - .	
		*/  
      bool                    Fill        (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_FILL));} 		
		
		/*!	
			  OBJPROP_SELECTED.
			\param  long aChartID -  ,
         \param  string aName -   . 			
		 	\return   bool. True - , false -  .	
		*/  
      bool                    Selected    (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_SELECTED));} 		
		
		/*!	
			     " " OBJPROP_SELECTED.
			\param  long aChartID -  ,
         \param  string aName -   . 			
		 	\return   bool. True -  , false - .	
		*/  
      bool                    ReadOnly    (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_READONLY));} 		
		
		/*!	
			  OBJPROP_TYPE.
			\param  long aChartID -  ,
         \param  string aName -   . 			
		 	\return   ENUM_OBJECT.	
		*/  
      ENUM_OBJECT             Type        (long aChartID,string aName)             {return( (ENUM_OBJECT)              ObjectGetInteger(aChartID,aName,OBJPROP_TYPE));}
		
		/*!	
			      OBJPROP_TIME.
			\param   long aChartID -  ,
         \param   string aName -   ,
         \param   int aIndex -    ( ).
		 	\return    ( datetime).		
		*/  
      datetime                Time        (long aChartID,string aName,int aIndex)  {return( (datetime)                 ObjectGetInteger(aChartID,aName,OBJPROP_TIME,aIndex));}	
		
		/*!	
			   OBJPROP_SELECTABLE.
			\param  long aChartID -  ,
         \param  string aName -   . 			
		 	\return   bool. True -  , false - .	
		*/   
      bool                    Selectable  (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_SELECTABLE));} 		
		
		/*!	
			   OBJPROP_CREATETIME.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return    ( datetime).		
		*/  
      datetime                CreateTime  (long aChartID,string aName)             {return( (datetime)                 ObjectGetInteger(aChartID,aName,OBJPROP_CREATETIME));}	
		
		/*!	
			  OBJPROP_LEVELS).
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   ( int).		
		*/  
      int                     Levels      (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_LEVELS));}	
		
		/*!	
			  OBJPROP_LEVELCOLOR.
			\param  long aChartID -  ,
         \param   int aIndex -   ( ).
         \param  string aName -   . 			         
		 	\return    ( color).		
		*/ 
      color                   LevelColor  (long aChartID,string aName,int aIndex)  {return( (color)                    ObjectGetInteger(aChartID,aName,OBJPROP_LEVELCOLOR,aIndex));}		
		
		/*!	
			  OBJPROP_LEVELSTYLE.
			\param  long aChartID -  ,
         \param   int aIndex -   ( ).
         \param  string aName -   . 			         
		 	\return    ( ENUM_LINE_STYLE).		
		*/  
      ENUM_LINE_STYLE         LevelStyle  (long aChartID,string aName,int aIndex)  {return( (ENUM_LINE_STYLE)          ObjectGetInteger(aChartID,aName,OBJPROP_LEVELSTYLE,aIndex));}	
		
		/*!	
			  OBJPROP_LEVELWIDTH.
			\param  long aChartID -  ,
         \param   int aIndex -   ( ).
         \param  string aName -   . 			         
		 	\return    ( int).		
		*/  
      int                     LevelWidth  (long aChartID,string aName,int aIndex)  {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_LEVELWIDTH,aIndex));}		
		
		/*!	
			  OBJPROP_FONTSIZE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return    ( int).		
		*/  
      int                     FontSize    (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_FONTSIZE));}		   
		
		/*!	
			   OBJPROP_RAY_LEFT.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   bool. True -   , false -  .		
		*/  
      bool                    RayLeft     (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_RAY_LEFT));} 	
		
		/*!	
			   OBJPROP_RAY_RIGHT.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   bool. True -   , false -  .		
		*/ 
      bool                    RayRight    (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_RAY_RIGHT));} 		
		
		/*!	
			       OBJPROP_RAY.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   bool. True -     , false -   .		
		*/  
      bool                    Ray         (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_RAY));} 		
		
		/*!	
			    " " OBJPROP_ELLIPSE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   bool. True -  , false - .		
		*/ 
      bool                    Ellipse     (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_ELLIPSE));} 			   
		
		/*!	
			    "" OBJPROP_ARROWCODE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return    ( char).
		*/ 
      char                    ArrowCode   (long aChartID,string aName)             {return( (char)                     ObjectGetInteger(aChartID,aName,OBJPROP_ARROWCODE));}
		
		/*!	
			    OBJPROP_TIMEFRAMES.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return     ( long).
		*/ 
      long                    TimeFrames  (long aChartID,string aName)             {return(                            ObjectGetInteger(aChartID,aName,OBJPROP_TIMEFRAMES));}
		
		/*!	
			   OBJPROP_ANCHOR.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return     ( long).  OBJ_ARROW    ENUM_ARROW_ANCHOR,  OBJ_LABEL  OBJ_TEXT -    ENUM_ANCHORPOINT.
		*/ 
      long                    Anchor      (long aChartID,string aName)             {return(                            ObjectGetInteger(aChartID,aName,OBJPROP_ANCHOR));}
		
		/*!	
			     X    OBJPROP_XDISTANCE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   ( int).
		*/ 
      int                     XDistance   (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_XDISTANCE));}	
		
		/*!	
			     Y    OBJPROP_YDISTANCE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   ( int).
		*/  
      int                     YDistanse   (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_YDISTANCE));}	
		
		/*!	
			   OBJPROP_DIRECTION.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   ( ENUM_GANN_DIRECTION).
		*/   
      ENUM_GANN_DIRECTION     Direction   (long aChartID,string aName)             {return( (ENUM_GANN_DIRECTION)      ObjectGetInteger(aChartID,aName,OBJPROP_DIRECTION));}
		
		/*!	
			    OBJPROP_DEGREE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   ( ENUM_ELLIOT_WAVE_DEGREE).
		*/ 
      ENUM_ELLIOT_WAVE_DEGREE Degree      (long aChartID,string aName)             {return( (ENUM_ELLIOT_WAVE_DEGREE)  ObjectGetInteger(aChartID,aName,OBJPROP_DEGREE));}
		
		/*!	
			      OBJPROP_DRAWLINES.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   bool. True - , false - .		
		*/  
      bool                    DrawLines   (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_DRAWLINES));} 
		
		/*!	
			  (/) OBJPROP_STATE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   bool. True - , false - .
		*/ 
      bool                    State       (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_STATE));} 
		
		/*!	
			  "" OBJPROP_CHART_ID.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return    ( long).
		*/ 
      long                    ChartChartID(long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_CHART_ID));}
		
		/*!	
			   OBJPROP_XSIZE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return    ( int).
		*/   
      int                     XSize       (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_XSIZE));}	
		
		/*!	
			   OBJPROP_YSIZE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return    ( int).
		*/ 
      int                     YSize       (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_YSIZE));}		
		
		/*!	
			 X     OBJPROP_XOFFSET.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   ( int).
		*/ 
      int                     XOffset     (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_XOFFSET));}	
		
		/*!	
			 Y     OBJPROP_YOFFSET.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   ( int).
		*/ 
      int                     YOffset     (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_YOFFSET));}	
		
		/*!	
			  "" OBJPROP_PERIOD.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   ( ENUM_TIMEFRAMES).
		*/ 
      ENUM_TIMEFRAMES         Period      (long aChartID,string aName)             {return( (ENUM_TIMEFRAMES)          ObjectGetInteger(aChartID,aName,OBJPROP_PERIOD));}
		
		/*!	
			      "" OBJPROP_DATE_SCALE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   bool. True -  , false -  .
		*/ 
      bool                    DateScale   (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_DATE_SCALE));} 
		
		/*!	
			      "" OBJPROP_PRICE_SCALE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   bool. True -  , false -  .
		*/  
      bool                    PriceScale  (long aChartID,string aName)             {return( (bool)                     ObjectGetInteger(aChartID,aName,OBJPROP_PRICE_SCALE));} 
		
		/*!	
			   "" OBJPROP_CHART_SCALE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
      	\return   1-5 ( int).
		*/  
      int                     ChartScale  (long aChartID,string aName)             {return( (int)                      ObjectGetInteger(aChartID,aName,OBJPROP_CHART_SCALE));}		
		
		/*!	
			  OBJPROP_BGCOLOR.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return    ( color).		
		*/  
      color                   BgColor     (long aChartID,string aName)             {return( (color)                    ObjectGetInteger(aChartID,aName,OBJPROP_BGCOLOR));}
		
		/*!	
			      OBJPROP_CORNER.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   ( ENUM_BASE_CORNER).
		*/  
      ENUM_BASE_CORNER        Corner      (long aChartID,string aName)             {return( (ENUM_BASE_CORNER)         ObjectGetInteger(aChartID,aName,OBJPROP_CORNER));}
		
		/*!	
			    " " OBJPROP_BORDER_TYPE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   ( ENUM_BORDER_TYPE).
		*/   
      ENUM_BORDER_TYPE        BorderType  (long aChartID,string aName)             {return( (ENUM_BORDER_TYPE)         ObjectGetInteger(aChartID,aName,OBJPROP_BORDER_TYPE));}
		
		/*!	
			  OBJPROP_PRICE.
			\param  long aChartID -  ,
         \param  string aName -   ,			
         \param   int aIndex -   ( ).
		 	\return   ( double).
		*/ 
      double                  Price       (long aChartID,string aName,int aIndex)  {return(                            ObjectGetDouble(aChartID,aName,OBJPROP_PRICE,aIndex));} 
		
		/*!	
			  OBJPROP_LEVELVALUE.
			\param  long aChartID -  ,
         \param  string aName -   ,			
         \param   int aIndex -   ( ).
		 	\return   ( double).
		*/ 
      double                  LevelValue  (long aChartID,string aName,int aIndex)  {return(                            ObjectGetDouble(aChartID,aName,OBJPROP_LEVELVALUE,aIndex));}  
		
		/*!	
			 (     " ") OBJPROP_SCALE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   ( double).
		*/ 
      double                  Scale       (long aChartID,string aName)             {return(                            ObjectGetDouble(aChartID,aName,OBJPROP_SCALE));}
		
		/*!	
			 OBJPROP_ANGLE.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   ( double).
		*/ 
      double                  Angle       (long aChartID,string aName)             {return(                            ObjectGetDouble(aChartID,aName,OBJPROP_ANGLE));}
		
		/*!	
			     OBJPROP_DEVIATION.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   ( double).
		*/ 
      double                  Deviation   (long aChartID,string aName)             {return(                            ObjectGetDouble(aChartID,aName,OBJPROP_DEVIATION));}
		
		/*!	
			    OBJPROP_TEXT.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return  .
		*/  
      string                  Text        (long aChartID,string aName)             {return(                            ObjectGetString(aChartID,aName,OBJPROP_TEXT));}
		
		/*!	
			  . OBJPROP_TOOLTIP.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return  .
		 	\remark      "\n".
		*/  
      string                  ToolTip     (long aChartID,string aName)             {return(                            ObjectGetString(aChartID,aName,OBJPROP_TOOLTIP));}
		
		/*!	
			 . OBJPROP_LEVELTEXT.
			\param  long aChartID -  ,
         \param  string aName -   ,		
         \param   int aIndex -   ( ).			
		 	\return  .
		*/ 
      string                  LevelText   (long aChartID,string aName,int aIndex)  {return(                            ObjectGetString(aChartID,aName,OBJPROP_LEVELTEXT,aIndex));} 
		
		/*!	
			 . OBJPROP_FONT.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   ( string).
		*/   
      string                  Font        (long aChartID,string aName)             {return(                            ObjectGetString(aChartID,aName,OBJPROP_FONT));}
		
		/*!	
			     "" OBJPROP_BMPFILE,  0.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return    ( string).
		*/  
      string                  BmpFileOn   (long aChartID,string aName)             {return(                            ObjectGetString(aChartID,aName,OBJPROP_BMPFILE,0));}
		
		/*!	
			     "" OBJPROP_BMPFILE,  1.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return    ( string).
		*/  
      string                  BmpFileOff  (long aChartID,string aName)             {return(                            ObjectGetString(aChartID,aName,OBJPROP_BMPFILE,1));}       
		
		/*!	
			   "" OBJPROP_SYMBOL.
			\param  long aChartID -  ,
         \param  string aName -   . 						
		 	\return   ( string).
		*/  
      string                  Symbol      (long aChartID,string aName)             {return(                            ObjectGetString(aChartID,aName,OBJPROP_SYMBOL));}  
      
      //+------------------------------------------------------------------+
      //|              |
      //+------------------------------------------------------------------+     

		/*!	
			  OBJPROP_COLOR.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		color aValue -  .			
		*/  
      void SetColor        (long aChartID,string aName,color aValue)                        {ObjectSetInteger(aChartID,aName,OBJPROP_COLOR,           aValue);}
		/*!	
			  OBJPROP_STYLE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		ENUM_LINE_STYLE aValue -  .			
		*/
      void SetStyle        (long aChartID,string aName,ENUM_LINE_STYLE aValue)              {ObjectSetInteger(aChartID,aName,OBJPROP_STYLE,           aValue);}
		
		/*!	
			  OBJPROP_WIDTH.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		int aValue -  .			
		*/ 
      void SetWidth        (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_WIDTH,           aValue);} 
		
		/*!	
			   /  OBJPROP_BACK.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		bool aValue - true/false (/ ).
		*/ 
      void SetBack         (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_BACK,            aValue);} 	
		
		/*!	
			  OBJPROP_FILL.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		bool aValue - true/false (/).
		*/ 
      void SetFill         (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_FILL,            aValue);} 		
		
		/*!	
			  OBJPROP_SELECTED.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		bool aValue - true/false (/ ).
		*/ 
      void SetSelected     (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_SELECTED,        aValue);} 		
		
		/*!	
			      " " OBJPROP_READONLY.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		bool aValue - true/false (/).
		*/  
      void SetReadOnly     (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_READONLY,        aValue);} 		
		
		/*!	
			      OBJPROP_TIME.
			\param   long aChartID -  ,
         \param   int aIndex -   ( ),
         \param   string aName -   ,
         \param   datetime aValue -  .
		*/    
      void SetTime         (long aChartID,string aName,int aIndex,datetime aValue)          {ObjectSetInteger(aChartID,aName,OBJPROP_TIME,            aIndex,aValue);}	
		
		/*!	
			    OBJPROP_SELECTABLE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		bool aValue - true/false (/).
		*/ 
      void SetSelectable   (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_SELECTABLE,      aValue);} 		
		
		/*!	
			   OBJPROP_LEVELS.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param		int aValue -  .
		*/  
      void SetLevels       (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_LEVELS,          aValue);}	
		
		/*!	
			   OBJPROP_LEVELCOLOR.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aIndex -   ( ),
         \param   color aValue -  .
		*/ 
      void SetLevelColor   (long aChartID,string aName,int aIndex,color aValue)             {ObjectSetInteger(aChartID,aName,OBJPROP_LEVELCOLOR,      aIndex,aValue);}		
		
		/*!	
			   OBJPROP_LEVELSTYLE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aIndex -   ( ),
         \param   ENUM_LINE_STYLE aValue -  .
		*/  
      void SetLevelStyle   (long aChartID,string aName,int aIndex,ENUM_LINE_STYLE aValue)   {ObjectSetInteger(aChartID,aName,OBJPROP_LEVELSTYLE,      aIndex,aValue);}
		
		/*!	
			   OBJPROP_LEVELWIDTH.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aIndex -   ( ),
         \param   int aValue -  .
		*/  
      void SetLevelWidth   (long aChartID,string aName,int aIndex,int aValue)               {ObjectSetInteger(aChartID,aName,OBJPROP_LEVELWIDTH,      aIndex,aValue);}		
		
		/*!	
			   OBJPROP_FONTSIZE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aValue -  .
		*/  
      void SetFontSize     (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_FONTSIZE,        aValue);}		   
		
		/*!	
			   OBJPROP_RAY_LEFT.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/   
      void SetRayLeft      (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_RAY_LEFT,        aValue);} 	
		
		/*!	
			   OBJPROP_RAY_RIGHT.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/  
      void SetRayRight     (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_RAY_RIGHT,       aValue);} 		
		
		/*!	
			      OBJPROP_RAY.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetRay          (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_RAY,             aValue);} 		
		
		/*!	
			   " "   OBJPROP_ELLIPSE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetEllipse      (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_ELLIPSE,         aValue);} 			   
		
		/*!	
			   OBJPROP_ARROWCODE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   char aValue -  .
		*/ 
      void SetArrowCode    (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_ARROWCODE,       aValue);}
		
		/*!	
			     OBJPROP_TIMEFRAMES.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   long aValue -   .
		*/   
      void SetTimeFrames   (long aChartID,string aName,long aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_TIMEFRAMES,      aValue);}
		
		/*!	
			   OBJPROP_ANCHOR.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   long aValue -   (ENUM_ARROW_ANCHOR  ENUM_ANCHORPOINT).
		*/   
      void SetAnchor       (long aChartID,string aName,long aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_ANCHOR,          aValue);}
		
		/*!	
			    X    OBJPROP_XDISTANCE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aValue -  .
		*/   
      void SetXDistance    (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_XDISTANCE,       aValue);}	
		
		/*!	
			    Y    OBJPROP_YDISTANCE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aValue -  .
		*/ 
      void SetYDistanse    (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_YDISTANCE,       aValue);}	
		
		/*!	
			    OBJPROP_DIRECTION.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   ENUM_GANN_DIRECTION aValue -  .
		*/ 
      void SetDirection    (long aChartID,string aName,ENUM_GANN_DIRECTION aValue)          {ObjectSetInteger(aChartID,aName,OBJPROP_DIRECTION,       aValue);}
		
		/*!	
			     OBJPROP_DEGREE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   ENUM_ELLIOT_WAVE_DEGREE aValue -  .
		*/ 
      void SetDegree       (long aChartID,string aName,ENUM_ELLIOT_WAVE_DEGREE aValue)      {ObjectSetInteger(aChartID,aName,OBJPROP_DEGREE,          aValue);}
		
		/*!	
			      OBJPROP_DRAWLINES.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetDrawLines    (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_DRAWLINES,       aValue);} 
		
		/*!	
			  .
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetState        (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_STATE,           aValue);} 
		
		/*!	
			   OBJPROP_XSIZE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aValue -  .
		*/ 
      void SetXSize        (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_XSIZE,           aValue);}	
		
		/*!	
			   OBJPROP_YSIZE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aValue -  .
		*/  
      void SetYSize        (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_YSIZE,           aValue);}		
		
		/*!	
			  X    OBJPROP_XOFFSET.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aValue -  .
		*/ 
      void SetXOffset      (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_XOFFSET,         aValue);}	
		
		/*!	
			  Y    OBJPROP_YOFFSET.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aValue -  .
		*/ 
      void SetYOffset      (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_YOFFSET,         aValue);}	
		
		/*!	
			   "" OBJPROP_PERIOD.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   ENUM_TIMEFRAMES aValue -  .
		*/ 
      void SetPeriod       (long aChartID,string aName,ENUM_TIMEFRAMES aValue)              {ObjectSetInteger(aChartID,aName,OBJPROP_PERIOD,          aValue);}
		
		/*!	
			/     "" OBJPROP_DATE_SCALE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetDateScale    (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_DATE_SCALE,      aValue);} 

		/*!	
			/     "" OBJPROP_PRICE_SCALE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   bool aValue - true/false (/).
		*/ 
      void SetPriceScale   (long aChartID,string aName,bool aValue)                         {ObjectSetInteger(aChartID,aName,OBJPROP_PRICE_SCALE,     aValue);} 

		/*!	
			    "" OBJPROP_CHART_SCALE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aValue -  1-5.
		*/  
      void SetChartScale   (long aChartID,string aName,int aValue)                          {ObjectSetInteger(aChartID,aName,OBJPROP_CHART_SCALE,     aValue);}		

		/*!	
			   OBJPROP_BGCOLOR.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   color aValue -  .
		*/    
      void SetBgColor      (long aChartID,string aName,color aValue)                        {ObjectSetInteger(aChartID,aName,OBJPROP_BGCOLOR,         aValue);}

		/*!	
			     OBJPROP_CORNER.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   ENUM_BASE_CORNER aValue -  .
		*/  
      void SetCorner       (long aChartID,string aName,ENUM_BASE_CORNER aValue)             {ObjectSetInteger(aChartID,aName,OBJPROP_CORNER,          aValue);}

		/*!	
			     " " OBJPROP_BORDER_TYPE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   ENUM_BORDER_TYPE aValue -  .
		*/  
      void SetBorderType   (long aChartID,string aName,ENUM_BORDER_TYPE aValue)             {ObjectSetInteger(aChartID,aName,OBJPROP_BORDER_TYPE,     aValue);}      

		/*!	
			   OBJPROP_PRICE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aIndex -   ( ),
		 	\param  double aValue - .
		*/  
      void SetPrice        (long aChartID,string aName,int aIndex,double aValue)            {ObjectSetDouble(aChartID,aName,OBJPROP_PRICE,            aIndex,aValue);} 

		/*!	
			   OBJPROP_LEVELVALUE.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aIndex -   ( ),
		 	\param  double aValue - .
		*/  
      void SetLevelValue   (long aChartID,string aName,int aIndex,double aValue)            {ObjectSetDouble(aChartID,aName,OBJPROP_LEVELVALUE,       aIndex,aValue);}  

		/*!	
			  (     " ") OBJPROP_SCALE.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  double aValue -  .
		*/ 
      void SetScale        (long aChartID,string aName,double aValue)                       {ObjectSetDouble(aChartID,aName,OBJPROP_SCALE,            aValue);}     

		/*!	
			  OBJPROP_ANGLE.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  double aValue -   OBJPROP_ANGLE.
		*/   
      void SetAngle        (long aChartID,string aName,double aValue)                       {ObjectSetDouble(aChartID,aName,OBJPROP_ANGLE,            aValue);}

		/*!	
			     OBJPROP_DEVIATION.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  double aValue -   (  ).
		*/ 
      void SetDeviation    (long aChartID,string aName,double aValue)                       {ObjectSetDouble(aChartID,aName,OBJPROP_DEVIATION,        aValue);}

		/*!	
			  OBJPROP_TEXT.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  string aValue - .
		*/ 
      void SetText         (long aChartID,string aName,string aValue)                       {ObjectSetString(aChartID,aName,OBJPROP_TEXT,             aValue);}

		/*!	
			   OBJPROP_TOOLTIP.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  string aValue - .
		 	\remark      "\n".		 	
		*/
      void SetToolTip      (long aChartID,string aName,string aValue)                       {ObjectSetString(aChartID,aName,OBJPROP_TOOLTIP,          aValue);}

		/*!	
			   OBJPROP_LEVELTEXT.
			\param  long aChartID -  ,
			\param  string aName -   ,
         \param   int aIndex -   ( ),
		 	\param  string aValue - . 	
		*/  
      void SetLevelText    (long aChartID,string aName,int aIndex,string aValue)            {ObjectSetString(aChartID,aName,OBJPROP_LEVELTEXT,        aIndex,aValue);} 

		/*!	
			   OBJPROP_FONT.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  string aValue -  . 	
		*/ 
      void SetFont         (long aChartID,string aName,string aValue)                       {ObjectSetString(aChartID,aName,OBJPROP_FONT,             aValue);} 

		/*!	
			     "" OBJPROP_BMPFILE,  0.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  string aValue -  . 	
		*/  
      void SetBmpFileOn    (long aChartID,string aName,string aValue)                       {ObjectSetString(aChartID,aName,OBJPROP_BMPFILE,          0,aValue);}       

		/*!	
			     "" OBJPROP_BMPFILE,  1.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  string aValue -  . 	
		*/  
      void SetBmpFileOff   (long aChartID,string aName,string aValue)                       {ObjectSetString(aChartID,aName,OBJPROP_BMPFILE,          1,aValue);}       

		/*!	
			    "" OBJPROP_SYMBOL.
			\param  long aChartID -  ,
			\param  string aName -   ,
		 	\param  string aValue - . 	
		*/  
      void SetSymbol       (long aChartID,string aName,string aValue)                       {ObjectSetString(aChartID,aName,OBJPROP_SYMBOL,           aValue);}  

      //+------------------------------------------------------------------+
      //|                                                      |
      //+------------------------------------------------------------------+         

      // ===  ===

		/*!	
			  .
		*/ 
      void Delete(){ObjectDelete(m_id,m_name);} 
		
		/*!	
			   .
			\param  string aName -   .
		*/       
      void Delete(string aName){ObjectDelete(0,aName);} 
		
		/*!	
			      .
			\param  long aChartID -  ,
			\param  string aName -   .
		*/       
      void Delete(long aChartID,string aName){ObjectDelete(aChartID,aName);} 

      // ===  ===

		/*!	
			  .
			\param   int aIndex -   ( ),
			\param   datetime aTime  -  ,
			\param   double aPrice -   .
		*/ 
      void Move(int aIndex,datetime aTime,double aPrice){
         ObjectMove(m_id,m_name,aIndex,aTime,aPrice);   
      }
      
		/*!	
			   .
			\param  string aName -   ,
			\param   int aIndex -   ( ),
			\param   datetime aTime  -  ,
			\param   double aPrice -   .			
		*/         
      void Move(string aName,int aIndex,datetime aTime,double aPrice){
         ObjectMove(0,aName,aIndex,aTime,aPrice);   
      }    
      
		/*!	
			     .
			\param  long aChartID -  ,
			\param  string aName -   ,
			\param   int aIndex -   ( ),
			\param   datetime aTime  -  ,
			\param   double aPrice -   .			
		*/           
      void Move(long aChartID,string aName,int aIndex,datetime aTime,double aPrice){
         ObjectMove(aChartID,aName,aIndex,aTime,aPrice);   
      }
      
      // ===  ===
           
		/*!	
			  .
			\return   , -1     ( int). 
		*/ 
      int Find(){
         return(ObjectFind(m_id,m_name));
      }  
      
		/*!	
			   .
			\param  string aName -   .
			\return   , -1     ( int). 
		*/              
      int Find(string aName){
         return(ObjectFind(0,aName));
      }    
      
		/*!	
			      .
			\param  long aChartID -  ,
			\param  string aName -   .
			\return   , -1     ( int). 
		*/         
      int Find(long aChartID,string aName){
         return(ObjectFind(aChartID,aName));
      }   
      
      // ===     ===
      
		/*!	
			      .
			\param  double aValue - ,
			\param  int aLineID -   ( ).
			\return   ( datetime). 
		*/ 
      datetime GetTimeByValue(double aValue,int aLineID=0){
         return(ObjectGetTimeByValue(m_id,m_name,aValue,aLineID));
      }         
      
		/*!	
			       .
			\param  string aName -   ,
			\param  double aValue - ,
			\param  int aLineID -   ( ).
			\return   ( datetime). 
		*/       
      datetime GetTimeByValue(string aName,double aValue,int aLineID=0){
         return(ObjectGetTimeByValue(0,aName,aValue,aLineID));
      }    

		/*!	
			          .
			\param  long aChartID -  ,
			\param  string aName -   ,			
			\param  double aValue - ,
			\param  int aLineID -   ( ).
			\return   ( datetime). 
		*/ 	      
      datetime GetTimeByValue(long aChartID,string aName,double aValue,int aLineID=0){
         return(ObjectGetTimeByValue(aChartID,aName,aValue,aLineID));
      }   

      // ===     ===
      
		/*!	
			      .
			\param  datetime aTime - ,
			\param  int aLineID -   ( ).
			\return  ( double). 
		*/ 
      double GetValueByTime(datetime aTime,int aLineID=0){
         return(ObjectGetValueByTime(m_id,m_name,aTime,aLineID));
      }   
      
		/*!	
			      .
			\param  string aName -   ,	
			\param  datetime aTime - ,
			\param  int aLineID -   ( ).
			\return  ( double). 
		*/             
      double GetValueByTime(string aName,datetime aTime,int aLineID=0){
         return(ObjectGetValueByTime(0,aName,aTime,aLineID));
      }
          
		/*!	
			          .
			\param  long aChartID -  ,
			\param  string aName -   ,	
			\param  datetime aTime - ,
			\param  int aLineID -   ( ).
			\return  ( double). 
		*/         
      double GetValueByTime(long aChartID,string aName,datetime aTime,int aLineID=0){
         return(ObjectGetValueByTime(aChartID,aName,aTime,aLineID));
      } 
      

      // === === === === ===
   
      /*!
            .   
         \param   aChartID=0 -  ,
         \param   int aSubWindow=-1 -  ,
         \param   int aType=-1 -  .
      */      
      int Total(int aChartID=0,int aSubWindow=-1,int aType=-1){
         return(ObjectsTotal(aChartID,aSubWindow,aType));
      }   
      
      /*!
              .   
      */ 
      void Redraw(){
         ChartRedraw(m_id);
      }  
      /*!
           .  
         \param long aChartID -  . 
      */              
      void Redraw(long aChartID=0){
         ChartRedraw(aChartID);
      }         
                 
};

CGraphicObjectShell g;

//+------------------------------------------------------------------+
//|                                                                  |
//|          CWorkPiece                                         |
//|                                                                  |
//+------------------------------------------------------------------+

/*!
	\brief           .
	
	\details          
	            .     
	               .

   \remark	       "w".
*/   

class CWorkPiece{
   public:
		/*!	
			 .
            \param		string aName="Canvas" - ,
            \param		int aSubWindow=0 - ,
            \param		int aLeft=100 -     ,
            \param		int aTop=100 -     ,
            \param		int aWidth=300 - ,
            \param		int aHeight=150 - ,
            \param		color aColorBg=clrIvory -  ,
            \param		int aColorBorder=clrDimGray -  .
            \remark	     -   .
		*/
      void Canvas(string aName="Canvas",int aSubWindow=0,int aLeft=100,int aTop=100,int aWidth=300,int aHeight=150,color aColorBg=clrIvory,int aColorBorder=clrDimGray){
         g.CreateRectangleLabel(aName,aSubWindow); //   
         g.SetXDistance(aLeft); //   X
         g.SetYDistanse(aTop); //   Y
         g.SetXSize(aWidth); //  
         g.SetYSize(aHeight); //  
         g.SetBgColor(aColorBg); //   
         g.SetColor(aColorBorder); //   
         g.SetCorner(CORNER_LEFT_UPPER); //   
         g.SetBorderType(BORDER_FLAT); //   
         g.SetTimeFrames(OBJ_ALL_PERIODS); //     
         g.SetSelected(false); //  
         g.SetSelectable(false); //    
         g.SetWidth(1); //   
         g.SetStyle(STYLE_SOLID); //   
      }
      
		/*!	
			.
            \param		string aName="Label" - ,
            \param		int aSubWindow=0 - ,
            \param		int aLeft=100 -     ,
            \param      int aTop=100 -     ,
            \param      string aText="Label" - ,
            \param      int aColor=clrDimGray - ,
            \param      int aFontSize=8 -  ,
            \param      string aFont="Arial" - .
            \remark	     -   .
		*/
      void Label(string aName="Label",int aSubWindow=0,int aLeft=100,int aTop=100,string aText="Label",int aColor=clrDimGray,int aFontSize=8,string aFont="Arial"){
         g.CreateLabel(aName,aSubWindow);
         g.SetXDistance(aLeft);
         g.SetYDistanse(aTop);
         g.SetText(aText);
         g.SetColor(aColor);
         g.SetFontSize(aFontSize);
         g.SetFont(aFont);
         g.SetCorner(CORNER_LEFT_UPPER);
         g.SetAnchor(ANCHOR_LEFT_UPPER);         
         g.SetSelected(false);
         g.SetSelectable(false);
      }  
      
		/*!	
			.
            \param		string aName="Button" - ,
            \param		int aSubWindow=0 - ,
            \param		int aLeft=100 -     ,
            \param		int aTop=100 -     ,
            \param		int aWidth=40 - ,
            \param		int aHeight=15 - ,
            \param		string aText="Button" -  ,
            \param		color aColorBg=clrSilver -  ,
            \param		color aColorText=clrBlack -  ,
            \param		int aFontSize=7 -   ,
            \param		string aFont="Arial" -  .
            \remark	     -   .
 		*/
      void Button(string aName="Button",int aSubWindow=0,int aLeft=100,int aTop=100,int aWidth=40,int aHeight=15,string aText="Button",color aColorBg=clrSilver,color aColorText=clrBlack,int aFontSize=7,string aFont="Arial"){
         g.CreateButton(aName,aSubWindow);
         g.SetXDistance(aLeft);
         g.SetYDistanse(aTop);
         g.SetXSize(aWidth);
         g.SetYSize(aHeight);
         g.SetText(aText);
         g.SetColor(aColorText);
         g.SetBgColor(aColorBg);
         g.SetFontSize(aFontSize);
         g.SetFont(aFont);
         g.SetCorner(CORNER_LEFT_UPPER);
         g.SetSelected(false);
         g.SetSelectable(false);
      } 
      
		/*!	
			 .
            \param		string aName="Edit" - ,
            \param		int aSubWindow=0 - ,
            \param		int aLeft=100 -     ,
            \param		int aTop=100 -     ,
            \param		int aWidth=40 - ,
            \param		int aHeight=15 - ,
            \param		string aText="Edit" - ,
            \param		color aColorBg=clrSnow -  ,
            \param		color aColorText=clrDimGray -    ,
            \param		int aFontSize=7 -  ,
            \param		string aFont="Arial" - .			
            \remark	     -   .
 		*/
      void Edit(string aName="Edit",int aSubWindow=0,int aLeft=100,int aTop=100,int aWidth=40,int aHeight=15,string aText="Edit",color aColorBg=clrSnow,color aColorText=clrDimGray,int aFontSize=7,string aFont="Arial"){
         g.CreateEdit(aName,aSubWindow);
         g.SetXDistance(aLeft);
         g.SetYDistanse(aTop);
         g.SetXSize(aWidth);
         g.SetYSize(aHeight);
         g.SetText(aText);
         g.SetColor(aColorText);
         g.SetBgColor(aColorBg);
         g.SetFontSize(aFontSize);
         g.SetFont(aFont);
         g.SetCorner(CORNER_LEFT_UPPER);
         g.SetSelected(false);
         g.SetSelectable(false);
         g.SetReadOnly(false);
      } 
      
		/*!	
			  .
            \param		string aName="Frame" - ,
            \param		int aSubWindow=0 - ,
            \param		int aLeft=100 -     ,
            \param		int aTop=100 -     ,
            \param		int aWidth=50 - ,
            \param		int aHeight=50 - ,
            \param		string aCaption="Frame" -  ,
            \param		int aCaptionWidth=31 -    ,
            \param		color aColorBg=clrIvory -  ,
            \param		color aColorBorder=clrDimGray -  ,
            \param		color aColorCaption=clrDimGray -  .
            \remark	     -   .
            \remark	       :  OBJ_RECTANGLE_LABEL (2 .)  
                        OBJ_LABEL.    ,    
                         .     ,   aCaption 
                          "",        . 
                               aName.   
                             aName    "_Frame", 
                          - "_FrameL",       - "_FrameC". 
 		*/
      void Frame(string aName="Frame",int aSubWindow=0,int aLeft=100,int aTop=100,int aWidth=50,int aHeight=50,string aCaption="Frame",int aCaptionWidth=31,color aColorBg=clrIvory,color aColorBorder=clrDimGray,color aColorCaption=clrDimGray){
         Canvas(aName+"_Frame",0,aLeft,aTop,aWidth,aHeight,aColorBg,aColorBorder);
            if(aCaption!=""){
               Canvas(aName+"_FrameC",aSubWindow,aLeft+4,aTop+2,aCaptionWidth,1,aColorBg,aColorBg);
               Label(aName+"_FrameL",aSubWindow,aLeft+6,aTop-5,aCaption,aColorCaption,7,"Arial");
            }               
      }
      
		/*!	
			   .
         \param   string aName="Frame" - .
 		*/
      void FrameDelete(string aName="Frame"){
         ObjectDelete(0,aName+"_Frame");
         ObjectDelete(0,aName+"_FrameC");
         ObjectDelete(0,aName+"_FrameL");         
      }  
           
		/*!	
			      "" .
         \param   string aName="Frame" - .
 		*/
      void Delete(string aName){
         ObjectDelete(0,aName);
      }   
         
		/*!	
			 "" .
 		*/
      void Redraw(){
         ChartRedraw(0);
      }         
};

CWorkPiece w;

//+------------------------------------------------------------------+
//|                                                                  |
//|          CColorSchemes                                      |
//|                                                                  |
//+------------------------------------------------------------------+

/*!
	\brief      .
	
	\details         
	          .

   \remark	       "ClrScheme".
*/   


class CColorSchemes{
   private:
      int m_ShemeIndex;
   public:
   		/*!	
   			  .
               \param		int aShemeIndex -   .
   		*/
         void SetScheme(int aShemeIndex){ //    
            m_ShemeIndex=aShemeIndex;
         }
   		/*!	
   			    .
               \param		int aColorIndex -    .
               \return		 .
   		*/         
         color Color(int aColorIndex){
            color m_Color[3][4];  //   -   ,  -    
            // default
            m_Color[0][0]=clrSnow;
            m_Color[0][1]=clrDimGray;
            m_Color[0][2]=clrDimGray;
            m_Color[0][3]=clrPink;
            // -
            m_Color[1][0]=clrLightYellow;
            m_Color[1][1]=clrBrown;
            m_Color[1][2]=clrBrown;
            m_Color[1][3]=clrPink;
            // 
            m_Color[2][0]=clrAliceBlue;
            m_Color[2][1]=clrNavy;
            m_Color[2][2]=clrNavy;
            m_Color[2][3]=clrPink;
            return(m_Color[m_ShemeIndex][aColorIndex]); //          
         }
   		/*!	
   			    .
             \remark	        ,   . 
                          ,   .
   		*/           
         void Show(){ //      
            int m_sc=3; //  
            int m_cc=4; //    
            color m_bcolor=Color(1);
            int m_RemScheme=m_ShemeIndex;
               for(int s=0;s<m_sc;s++){
                  w.Label("ColorSchemes_"+IntegerToString(s),0,10+s*20,20,IntegerToString(s),m_bcolor);
               }
               for(int s=0;s<m_sc;s++){
                  m_ShemeIndex=s;
                     for(int c=0;c<m_cc;c++){
                        w.Canvas("ColorSchemes_"+IntegerToString(s)+"_"+IntegerToString(c),0,10+s*20,20+15+c*20,20,20,Color(c),m_bcolor);
                     }
               }
            ChartRedraw(0);
            m_ShemeIndex=m_RemScheme;
         }
   		/*!	
   			     Show().
   		*/           
         void Hide(){ //      Show()
            int m_sc=3;
            int m_cc=4;         
               for(int s=0;s<m_sc;s++){
                  ObjectDelete(0,"ColorSchemes_"+IntegerToString(s));
                     for(int c=0;c<m_cc;c++){
                        ObjectDelete(0,"ColorSchemes_"+IntegerToString(s)+"_"+IntegerToString(c));
                     }
               }
            ChartRedraw(0);
         }
};

CColorSchemes ClrScheme;

//+------------------------------------------------------------------+
//|                                                                  |
//|                                         |
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|          CInputBox                                          |
//+------------------------------------------------------------------+

/*!
	\brief      " ".
	
	\details   :   ,   . 
	                  , 
	                 .
	                    
	            .    . 
   \remark	       " " (OBJ_EDIT) "" (OBJ_LABEL).
                   aName  "_E",   - "_L".
            
*/   

class CInputBox{
   private:
      string m_NameEdit;   //    Edit
      string m_NameLabel;  //    Label
      int m_Left;          //  
      int m_Top;           //  Y
      int m_Width;         // 
      int m_Height;        // 
      bool m_Visible;      //    
      int m_Digits;        //       double  -1     
      string m_Caption;    // 
      string m_Value;      // 
      double m_ValueMin;   //  
      double m_ValueMax;   //  
      color m_BgColor;     //   
      color m_TxtColor;    //  
      color m_LblColor;    //  
      color m_WarningColor;//   
      bool m_Warning;      //  
      int m_SubWindow;     // 
      string m_Tag;        // 
         void Create(){ //    
            color m_ctmp=m_BgColor; //   
               if(m_Warning){ //   
                  m_ctmp=m_WarningColor; //      
               }
            w.Edit(m_NameEdit,m_SubWindow,m_Left,m_Top,m_Width,m_Height,m_Value,m_ctmp,m_TxtColor,7,"Arial"); //   
               if(m_Caption!=""){ //  
                  w.Label(m_NameLabel,m_SubWindow,m_Left+m_Width+1,m_Top+2,m_Caption,m_LblColor,7,"Arial"); //  
               } 
         }   
         void Delete(){ //    
            ObjectDelete(0,m_NameEdit); //   
            ObjectDelete(0,m_NameLabel); //  
         }    
   public:
		/*!	
			  .
            \param		string aName="CInputBox" - ,
            \param		int aWidth=50 - ,
            \param		int aDigits=-1 -     (   ), -1 -    ,
            \param		string aCaption="CInputBox" -   (  ""  ).
 		*/   
      void Init(string aName="CInputBox",int aWidth=50,int aDigits=-1,string aCaption="CInputBox"){ //  
         m_NameEdit=aName+"_E"; //    
         m_NameLabel=aName+"_L"; //   
         m_Left=0; //  
         m_Top=0; //  Y
         m_Width=aWidth; // 
         m_Height=15; // 
         m_Visible=false; // 
         m_Digits=aDigits; //        
         m_Caption=aCaption; //  
         m_Value=""; //    
         if(aDigits>=0)m_Value=DoubleToString(0,m_Digits); //    
         m_ValueMin=-DBL_MAX; //  
         m_ValueMax=DBL_MAX; //  
         m_BgColor=ClrScheme.Color(0); //    
         m_TxtColor=ClrScheme.Color(1); //      
         m_LblColor=ClrScheme.Color(2); //  
         m_WarningColor=ClrScheme.Color(3); //  
         m_Warning=false; // : , 
         m_SubWindow=0; //  
         m_Tag=""; // 
      }
		/*!	
			  X  Y.
            \param		int aLeft -  X (    ),
            \param		int aTop -  Y (    ).
            \remark	      ,    Refresh().
 		*/        
      void SetPos(int aLeft,int aTop){ //   X  Y
         m_Left=aLeft;
         m_Top=aTop;
      }
		/*!	
			  X.
            \param		int aLeft -  X (    ).
            \remark	      ,    Refresh().
 		*/        
      void SetPosLeft(int aLeft){ //   X 
         m_Left=aLeft;
      }   
		/*!	
			  Y.
            \param		int aTop -  Y (    ).
            \remark	      ,    Refresh().
 		*/             
      void SetPosTop(int aTop){ //   Y
         m_Top=aTop;
      }  
		/*!	
			 .
            \param		int aWidth - .
            \remark	      ,    Refresh().
 		*/         
      void SetWidth(int aWidth){ //   
         m_Width=aWidth;
      }
		/*!	
			  X.
			\return   ( int).
 		*/       
      int Left(){ //   X
         return(m_Left);
      }
		/*!	
			  Y.
			\return   ( int).
 		*/        
      int Top(){ //   Y
         return(m_Top);
      }
		/*!	
			 .
			\return   ( int).
			\remark         .
 		*/        
      int Width(){ //  
         return(m_Width);
      }
		/*!	
			 .
			\return   ( int).
 		*/        
      int Height(){
         return(m_Height); //  
      }
		/*!	
			 .
 		*/       
      void Show(){ //      
         m_Visible=true; //   
         Create(); //   
         ChartRedraw(); //  
      }
		/*!	
			    .
         \param		int aLeft -  X (    ),
         \param		int aTop -  Y (    ).			
 		*/        
      void Show(int aLeft,int aTop){ //     
         SetPos(aLeft,aTop); //  
         Show(); //  
      }
		/*!	
			   (  ).
 		*/   
      void Hide(){ //  (  )
         m_Visible=false; //   
         Delete(); //   
         ChartRedraw(); //  
      }  
		/*!	
			 (     ).
 		*/         
      void Refresh(){ //   (  )
         if(m_Visible){ //  
            Delete(); //   
            Create(); //   
            ChartRedraw(); //   
         }            
      }  
		/*!	
			   string.
			\param		string aValue - .	
 		*/         
      void SetValue(string aValue){ //   
         m_Value=aValue; //      
            if(m_Visible){ //    
               g.Attach(m_NameEdit); //         
               g.SetText(m_Value); //     
               ChartRedraw(); //   
            }
      }  
		/*!	
			   double.
			\param		double aValue - .	
 		*/         
      void SetValue(double aValue){ //   
         if(m_Digits>=0){ //   
            aValue=NormalizeDouble(aValue,m_Digits); //        
            aValue=MathMax(aValue,m_ValueMin); // ""     
            aValue=MathMin(aValue,m_ValueMax); // ""     
            SetValue(DoubleToString(aValue,m_Digits)); //      
         }
         else{ //   
            SetValue((string)aValue); //        
         }            
      }
		/*!	
			  .
			\remark      OnChartEvent(),      OnChartEvent().
			\return  0  1. 0 -  . 1     .
 		*/          
      int Event(const int id,const long & lparam,const double & dparam,const string & sparam){ //  
         bool m_event=0; //      
            if(id==CHARTEVENT_OBJECT_ENDEDIT){ //      
               if(sparam==m_NameEdit){ //       m_NameEdit
                  if(m_Digits<0){ //   
                     g.Attach(m_NameEdit); //     
                        if(g.Text()!=m_Value){ //     
                           m_Value=g.Text(); //      
                           m_event=1; //  
                        }
                  }
                  else{ //   
                     string m_OldValue=m_Value; //      
                     g.Attach(m_NameEdit); //     
                     string m_stmp=g.Text(); //     ,  
                     StringReplace(m_stmp,",","."); //    
                     double m_dtmp=StringToDouble(m_stmp); //   
                     SetValue(m_dtmp); //    
                        if(StringToDouble(m_Value)!=StringToDouble(m_OldValue)){ //     
                           m_event=1; //   
                        }
                  }
               }
            }               
         return(m_event); //  . 0 -  , 1 -  
      }
		/*!	
			   .
			\param int aNumber -  .
 		*/       
      void SetSubWindow(int aNumber){ //    
         int m_itmp=(int)MathMax(aNumber,0); //    ,   0 -  
            if(m_itmp!=m_SubWindow){ //           
               m_SubWindow=m_itmp; //    
               Refresh(); //   
            }
      }  
		/*!	
			    .
			\param string aName -  .
 		*/              
      void SetSubWindow(string aName){ //     
         SetSubWindow(ChartWindowFind(0,aName)); //          
      }
		/*!	
			  .
			\return .
 		*/       
      string ValueStrind(){ //   
         return(m_Value);
      }
		/*!	
			  .
			\return  ( double).
 		*/         
      double ValueDouble(){ //   
         return(StringToDouble(m_Value));
      }
		/*!	
			/  .
			\param bool aValue - true/false (/). 
 		*/        
      void SetWarning(bool aValue){ //   
            if(m_Visible){ //  
               if(aValue){ //    
                  if(!m_Warning){ //     
                     g.Attach(m_NameEdit); //      
                     g.SetBgColor(m_WarningColor); //      
                  }
               }
               else{ //    
                  if(m_Warning){ //   
                     g.Attach(m_NameEdit); //      
                     g.SetBgColor(m_BgColor); //                    
                  }
               }
            }
         m_Warning=aValue; //   
      }
		/*!	
			  .
			\return  bool. True/false - /.
 		*/         
      bool Warning(){ //   
         return(m_Warning);
      }
		/*!	
			   .
			\param double aValue -   . 
 		*/        
      void SetMaxValue(double aValue){ //    
         m_ValueMax=aValue; //     
            if(m_Digits>=0){ //      
               if(StringToDouble(m_Value)>m_ValueMax){ //         
                  SetValue(m_ValueMax); //       
               }
            }         
      }
		/*!	
			   .
			\param double aValue -   . 
 		*/        
      void SetMinValue(double aValue){ //    
         m_ValueMin=aValue; //          
            if(m_Digits>=0){ //      
               if(StringToDouble(m_Value)<m_ValueMin){ //         
                  SetValue(m_ValueMin); //        
               }
            }
      }
		/*!	
			   .
			\return  ( double).
 		*/         
      double MaxValue(){ //    
         return(m_ValueMax); 
      }
		/*!	
			   .
			\return  ( double).
 		*/       
      double MinValue(){ //    
         return(m_ValueMin);
      }
		/*!	
			 .
			\param string aValue - .
 		*/       
      void SetTag(string aValue){ //  
         m_Tag=aValue;
      }
		/*!	
			 .
			\return  ( string).
 		*/        
      string Tag(){ //  
         return(m_Tag);
      }  
		/*!	
			       .
			\param int aValue -    .
 		*/          
      void SetDigits(int aValue){ //     
         m_Digits=aValue; //   
            if(m_Digits>=0){ //  
               SetValue(ValueDouble()); //   
            }
      }  
		/*!	
			    .
			\return  int.     -    . -1 -      .
 		*/       
      int Digits(){ //   m_Digits
         return(m_Digits);
      }   
		/*!	
			  .
			\return  bool. True/false - /.
 		*/           
      bool Visible(){
         return(m_Visible);
      }
};

